//---------------------------------------------------------------------------
#ifndef CyberpunkH
#define CyberpunkH
//---------------------------------------------------------------------------
AnsiString __fastcall CpkDir();
AnsiString __fastcall CpkPublicRing();
AnsiString __fastcall CpkRemLines(TStrings *CList=NULL);
AnsiString __fastcall CpkGetNewRemailerKeys(TStrings *KeyDoc);
void __fastcall CpkAddNewRemailerKeys(TStrings *KeyDoc, TStrings *Type1);
AnsiString __fastcall CpkGenType1(TStrings *Type1, TStrings *Keyring);
AnsiString __fastcall CpkType1Doubles(TStrings *Type1);
AnsiString __fastcall CpkListKeyNotFound(TStrings *CList, TStrings *Type1);
void __fastcall CpkBlockToKeys(TStrings *Block);
void __fastcall CpkKeysToBlock(TStrings *Keys);
// constants used for help windows
const AnsiString CyberpunkDocs = "Cyberpunk Online Documents"; // caption
const AnsiString UpdateCpkDocs = "UpdateCpkDocs"; // help section
const AnsiString CpkKeyDuplicate = "Duplicate Cyberpunk Keys";
const AnsiString CpkKeyNotFound = "Cyberpunk Keys Not Found";
const AnsiString CpkKeyNew = "New Cyberpunk Keys";
const AnsiString CpkUnknownRemailer = "<unknown remailer, no key/description available>";
const AnsiString noCkeyfound = "----------";
const AnsiString noDescription = "no_description";

bool __fastcall CpkRingLineOk(AnsiString &line);
bool __fastcall CpkListLineOk(AnsiString &line);

class TCpkKey : public TObject
{
public:
   int status;
   TStringList *Block;
   AnsiString Description;
   __fastcall TCpkKey(TStrings *Key);
   __fastcall ~TCpkKey();
};

class TCpkDb : public TObject
{
public:
   bool modified;
   TStringList *keys;
   AnsiString keyring;
   virtual __fastcall TCpkDb(AnsiString PubRing);
   virtual __fastcall TCpkDb(TStrings *PubKeys=NULL);
   virtual __fastcall ~TCpkDb();
   TCpkKey* __fastcall GetKey(int Pos);
   void __fastcall SaveToFile(AnsiString &FileName);
   void __fastcall SaveToStrings(TStrings *Strings);
   AnsiString __fastcall SaveToString();
   int __fastcall AddKeyStrings(TStrings *Key);
   int __fastcall AddKey(TCpkKey *Key);
   int __fastcall Find(TCpkKey* Key);
   int __fastcall FindDescrip(AnsiString &Descrip);
   int __fastcall Delete(int Item);
   void __fastcall Clear();
};

const AnsiString CpkBeginKeyBlock = "-----BEGIN PGP PUBLIC KEY BLOCK-----";
const AnsiString CpkEndKeyBlock = "-----END PGP PUBLIC KEY BLOCK-----";

//---------------------------------------------------------------------------
#endif
