//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <vcl\clipbrd.hpp>
#include <vcl\classes.hpp>
#pragma hdrstop

#include "HelpDlg.h"
#include "FileMan.h"
#include "Global.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
AnsiString HlpCap = "Help!";
THlpDlg *HlpDlg;
//---------------------------------------------------------------------------
void __fastcall OpenHelp(AnsiString &Section, AnsiString &Title,
   AnsiString &ActiveTab, TForm *Owner)
{
   HlpDlg = new THlpDlg(Section,Title,ActiveTab,Owner);
   HlpDlg->ShowModal();
   delete HlpDlg;
}
//---------------------------------------------------------------------------
__fastcall THlpDlg::THlpDlg(TComponent* Owner)
  : TForm(Owner)
{
   if (Owner) CenterDialog(this,(TForm*)Owner);
   tabs = new TStringList();
   Tabs = TabControl1->Tabs;
   Caption = HlpCap;
}
//---------------------------------------------------------------------------
__fastcall THlpDlg::THlpDlg(AnsiString &section, AnsiString &Title,
   AnsiString &ActiveTab, TComponent* Owner) : TForm(Owner)
{
   CenterDialog(this,(TForm*)Owner);
   Tabs = TabControl1->Tabs;
   Caption = HlpCap+" "+Title;
   tabs = new TStringList();
   Section = section;

   Tabs->Clear();
   AnsiString sec,tab;
   TStringList *secs = new TStringList();
   TStringList *tmps = new TStringList(); tmps->Sorted = true;
   secs->Text = Section;
   for (int s=0; s<secs->Count; s++)
   {
      GetAppData(tmps,secs->Strings[s],QSHelp());
      for (int i=0; i<tmps->Count; i++)
      {
         Tabs->AddObject(ChangeFileExt(tmps->Strings[i],""),NULL);
         tabs->Add(secs->Strings[s]+PS+ChangeFileExt(tmps->Strings[i],""));
      }
   }
   TopLine = new int[Tabs->Count];
   for (int i=0; i<Tabs->Count; i++)
      TopLine[i] = 0;
   int at = Tabs->IndexOf(ActiveTab); if (at<0) at=0;
   if (Tabs->Count)
   {
      TabControl1->TabIndex = at;
      LoadPage(at);
   }
   ActiveControl = Panel1;
   delete tmps;
   delete secs;
}
//---------------------------------------------------------------------------
__fastcall THlpDlg::~THlpDlg()
{
   TMemoryStream *ms;
   for (int i=0; i<Tabs->Count; i++)
   {
      if ((ms=dynamic_cast<TMemoryStream*>(Tabs->Objects[i]))!=NULL)
         delete ms;
   }
   delete [] TopLine;
   delete tabs;
}
//---------------------------------------------------------------------------
void __fastcall THlpDlg::FormPaint(TObject *Sender)
{
   TRect Rct = Rect(4,4,HelpText->ClientWidth-8,HelpText->ClientHeight-2);
   SendMessage(HelpText->Handle,EM_SETRECT,0,long(&Rct));
}
//---------------------------------------------------------------------------
void __fastcall THlpDlg::TabControl1Change(TObject *Sender)
{
   LoadPage(TabControl1->TabIndex);
}
//---------------------------------------------------------------------------
void __fastcall THlpDlg::TabControl1Changing(TObject *Sender, bool &AllowChange)
{
   TopLine[TabControl1->TabIndex] = HelpText->Perform(EM_GETFIRSTVISIBLELINE,0,0);
}
//---------------------------------------------------------------------------
void __fastcall THlpDlg::Print1Click(TObject *Sender)
{
   if (MsgBoxHwnd(Handle,"Print \""+Caption+"\" ?","Print",MB_OKCANCEL)==IDOK)
      HelpText->Print(Caption);
}
//---------------------------------------------------------------------------
void __fastcall THlpDlg::LoadPage(int Index)
{
   if (Index<0 || Index>=Tabs->Count) return;
   AnsiString name = Tabs->Strings[Index];
   TMemoryStream *ms = (TMemoryStream*)Tabs->Objects[Index];
   if (ms==NULL)
   {
      ms = new TMemoryStream();
      TStringList *txt = new TStringList();
      GetAppData(txt,tabs->Strings[Index]+".rtf",QSHelp());
      ms->Write(txt->Text.c_str(),txt->Text.Length());
      Tabs->Objects[Index] = ms;
      TopLine[Index] = 0;
      delete txt;
   }
   bool locked = LockWindowUpdate(Handle);
   ms->Seek(0,soFromBeginning);
   HelpText->Lines->LoadFromStream(ms);
   HelpText->Perform(EM_LINESCROLL,0,TopLine[Index]);
   Application->ProcessMessages();
   if (locked) LockWindowUpdate(0);
}
//---------------------------------------------------------------------------
void __fastcall THlpDlg::FormClose(TObject *Sender, TCloseAction &Action)
{
//   if (FormStyle==fsMDIChild) Action = caFree;
}
//---------------------------------------------------------------------------
