#define _WINSOCKAPI_      // Prevent winsock.h from being included
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "HttpDlg.h"
#include "Global.h"
#include "FileMan.h"
#include "UrlsDlg.h"
#include "Mixmaster.h"
#include "Cyberpunk.h"
#include "PgpMail.h"
#include "HelpDlg.h"
#include "docmsgdlg.h"
//---------------------------------------------------------------------------
#pragma link "HttpProt"
#pragma link "explbtn"
#pragma resource "*.dfm"
THttpForm *HttpForm;
AnsiString httpretval;
//---------------------------------------------------------------------------
bool __fastcall GetRemailerStats(TForm *owner, bool attended)
{
   HttpForm = new THttpForm(owner);
   CenterDialog(HttpForm,owner);
   bool ok = HttpForm->Execute(attended);
   delete HttpForm;
   return ok;
}
//---------------------------------------------------------------------------
__fastcall THttpForm::THttpForm(TComponent* Owner)
    : TForm(Owner)
{
   DocMemo->Font->Name = GetAppIni("FontName","Courier New");
   DocMemo->Font->Size = GetAppIni("FontSize","").ToIntDef(10);
   ErrorCheck->Checked = GetAppIni(StatsErrCheck,"").ToIntDef(1);
   CenterDialog(this);
   PageControl1->ActivePage = TabSheet1;
   Label1->Caption = "";

   LoadHttpInfo();
   HttpCli1->RcvdStream = NULL;
   Tabs = TabSet->Tabs;
   CancelAnyway = false;
   Cancelled = false;
   Attended = false;
}
//---------------------------------------------------------------------------
__fastcall THttpForm::~THttpForm()
{
   for (int i=0; i<Tabs->Count; i++)
      delete (TStringList*)Tabs->Objects[i];
   delete HttpCli1->RcvdStream;
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   SetTab(TabSet->TabIndex);
   switch (ModalResult)
   {
      case mrOk: SaveStatistics(); break;
      case mrCancel:
         if (GoodTabs())
         {
            switch (MsgBoxHwnd(Handle,
               "Your new remailer docs are not saved!\n\nSave them now?",
               "Remailer Documents",MB_YESNOCANCEL))
            {
               case ID_CANCEL:
                  CanClose = false;
                  break;
               case ID_YES:
                  SaveStatistics();
                  break;
            }
         }
   }
   if (!CanClose) return;

   if (CancelAnyway) ModalResult = mrCancel;
   PutAppIni(StatsErrCheck,ErrorCheck->Checked ? "1":"0");
   StoreHttpInfo();
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::CheckDocumentsExist()
{
   int reply;
   AnsiString mlisttxt=MixDir()+MListTxt,mringtxt=MixDir()+MRingTxt,
              clisttxt=MixDir()+CListTxt,cringtxt=MixDir()+CRingTxt;
   if (!Cancelled && !FileExists(mlisttxt) && !MListBox->Checked)
   {
      reply = MsgBoxHwnd(Handle,
        "Your 'mlist.txt' document is missing. Shall I get it while online?",
        "Mixmaster Statistics",
         MB_YESNOCANCEL
      );
      switch (reply)
      {
         case IDCANCEL:
            Cancelled = true;
            break;
         case IDYES:
            MListBox->Checked = true;
            break;
      }
   }
   else if (!Cancelled && !FileExists(mringtxt) && !MRingBox->Checked)
   {
      reply = MsgBoxHwnd(Handle,
        "Your 'pubring.mix' keyring is missing. Shall I get it while online?",
        "Mixmaster Keyring",
         MB_YESNOCANCEL
      );
      switch (reply)
      {
         case IDCANCEL:
            Cancelled = true;
            break;
         case IDYES:
            MRingBox->Checked = true;
            break;
      }
   }
   else if (!Cancelled && !FileExists(clisttxt) && !CListBox->Checked)
   {
      reply = MsgBoxHwnd(Handle,
        "Your 'rlist.txt' document is missing. Shall I get it while online?",
        "Cyberpunk Statistics",
         MB_YESNOCANCEL
      );
      switch (reply)
      {
         case IDCANCEL:
            Cancelled = true;
            break;
         case IDYES:
            CListBox->Checked = true;
            break;
      }
   }
   else if (!Cancelled && !FileExists(cringtxt) && !CRingBox->Checked)
   {
      reply = MsgBoxHwnd(Handle,
        "Your 'pubring.asc' keyring is missing. Shall I get it while online?",
        "Mixmaster Keyring",
         MB_YESNOCANCEL
      );
      switch (reply)
      {
         case IDCANCEL:
            Cancelled = true;
            break;
         case IDYES:
            CRingBox->Checked = true;
            break;
      }
   }
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::ClearDocuments()
{
   for (int t=0; t<Tabs->Count; t++)
      delete dynamic_cast<TStrings*>(Tabs->Objects[t]);
   DocMemo->Clear();
   Tabs->Clear();
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::GetDocsClick(TObject *Sender)
{
   bool cancel=false;
   if (!Tabs->Count) CheckDocumentsExist();
   if (GoodTabs())
   {
      switch (MsgBoxHwnd(Handle,
         "Your new remailer docs are not saved!\n\nSave them now?",
         "Remailer Documents",MB_YESNOCANCEL))
      {
         case ID_YES:
            SaveStatistics();
            break;
         case ID_CANCEL:
            cancel = true;
            break;
      }
   }
   if (cancel) return;
   ClearDocuments();
   GetBtnClick();
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::GetBtnClick()
{
   if (Cancelled)
   {
      ResetCheckboxes();
      return;
   }
   if (!Timer1->Enabled) Timer1->Enabled = true;
   if (GetDocs->Enabled && GetDocs->Caption=="Get Docs")
   {
      TabSheet1->Enabled = false;
      TabSheet2->Enabled = false;
   }
   GetDocs->Enabled = false;
   OkBtn->Enabled = false;

   if (MListBox->Enabled && MListBox->Checked)
      GetStatistics(MListURL,MListBox,MListTxt);
   else
   if (MRingBox->Enabled && MRingBox->Checked)
      GetStatistics(MRingURL,MRingBox,MRingTxt);
   else
   if (MTyp2Box->Enabled && MTyp2Box->Checked)
      GetStatistics(MTyp2URL,MTyp2Box,MTyp2Txt);
   else
   if (CListBox->Enabled && CListBox->Checked)
      GetStatistics(CListURL,CListBox,CListTxt);
   else
   if (CRingBox->Enabled && CRingBox->Checked)
      GetStatistics(CRingURL,CRingBox,CRingTxt);
   else
   {
      ResetCheckboxes();
      ProgressBar1->Visible = false; Label1->Caption = "";
      TabSet->TabIndex = TabSet->Tabs->Count-1;
      PageControl1->ActivePage = TabSheet3;

      if (ErrorCheck->Checked)
      {
         bool ok1=true,ok2=true,ok3=true,ok4=true;
         for (int i=0; i<Tabs->Count; i++)
         {
            TStringList *doc = dynamic_cast<TStringList*>(Tabs->Objects[i]);
            if (doc)
            {
               if (Tabs->Strings[i]==MListTxt) ok1=MixListOk(doc); else
               if (Tabs->Strings[i]==MRingTxt) ok2=MixRingOk(doc); else
               if (Tabs->Strings[i]==CListTxt) ok3=CListOk(doc); else
               if (Tabs->Strings[i]==CRingTxt) ok4=CRingOk(doc);
            }
         }
         if (!ok1 || !ok2 || !ok3 || !ok4)
         {
            CancelAnyway = true;
            Cancelled = true;
            Attended = true;
            GetDocs->Click();
         }
      }

      ActiveControl = DocMemo;
      TabSheet1->Enabled = true;
      TabSheet2->Enabled = true;
      UrlsBtn->Enabled = true;
      OkBtn->Enabled = true;
      Label1->Caption = "";
      Cancelled = false;

      if (ErrorCheck->Checked)
          ReportDocumentsAndProblems();

      if (Attended) MyBeep(MB_OK); // if attended, just this line
      else
      {
         ModalResult = !Cancelled || (Cancelled && Tabs->Count>1) ? mrOk:mrCancel;
         ProgressBar1->Visible = false;
         CancelBtn->Enabled = false;
         OkBtn->Enabled = false;
         Sleep(1000);
      }
   }
}
//---------------------------------------------------------------------------
TStrings* __fastcall THttpForm::LoadDocument(AnsiString &DocName)
{
   if (Tabs->IndexOf(DocName)<0)
   {
      TStringList *doc = new TStringList();
      if (FileExists(MixDir()+DocName)) doc->LoadFromFile(MixDir()+DocName);
      Tabs->AddObject(DocName,doc);
   }
   // special handling cpunk keyring
   if (DocName==CRingTxt && HasPgp())
   {
      TabSet->TabIndex = Tabs->IndexOf(DocName);
      TStrings *doc = dynamic_cast<TStrings*>(Tabs->Objects[Tabs->IndexOf(DocName)]);
      CpkBlockToKeys(doc);
      DocMemo->Lines->Text = doc->Text;
      DocMemo->SelStart = 0;
   }
   // end special
   Application->ProcessMessages(); Sleep(200);
   return dynamic_cast<TStrings*>(Tabs->Objects[Tabs->IndexOf(DocName)]);
}
//---------------------------------------------------------------------------
bool __fastcall THttpForm::CorruptDoc(TStrings *Doc)
{
   return Doc && Doc->Text.Trim().Pos(CorruptReport)==1;
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::SetTabCurrent(AnsiString &TabName, TStrings *TabDoc)
{
   TabSet->TabIndex = Tabs->IndexOf(TabName);
   Application->ProcessMessages();
   if (TabSet->TabIndex>=0)
   {
      DocMemo->Lines->Text = TabDoc->Text;
      DocMemo->SelStart = 0;
   }
}
//---------------------------------------------------------------------------
void __fastcall ClearTypeFile(AnsiString &TypeName)
{  // clears type1.list or type2.list of all but disables (#)
   TStringList *lines = new TStringList();
   if (FileExists(TypeName)) lines->LoadFromFile(TypeName);

   int i=0; while (i<lines->Count)
      if (lines->Strings[i].Pos("#")!=1) lines->Delete(i);
      else i++;

   lines->SaveToFile(TypeName);
   delete lines;
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::ReportDocumentsAndProblems()
{
   // LoadDocument returns a pointer to that document in the Tabs array.
   // If the document is not present on any Tab, it is loaded from disk
   // into the Tabs array. Either way, a pointer to the doc is returned.
   AnsiString md=MixDir();
   TStrings *mlist,*mring,*type2=NULL,*clist,*cring,*type1=NULL;
   try
   {
      // test mixmaster documents
      if (MListBox->Checked || MRingBox->Checked)
      {
         // if no pubring.mix, clear type2.list of all but disabled
         if (!FileExists(md+MRingTxt) && FileExists(md+MTyp2Txt))
            ClearTypeFile(md+MTyp2Txt); // dump all but #'s
         // pubring.mix update
         if (MRingBox->Checked && !CorruptDoc(mring=LoadDocument(MRingTxt)))
         {
            Perform(WM_SETREDRAW,0,0);
            type2 = LoadDocument(MTyp2Txt); // set tab to doc and load docmemo
            MixAddNewRemailerKeys(mring,type2); SetTabCurrent(MRingTxt,mring);
            MixGenType2(type2,mring);
            Perform(WM_SETREDRAW,1,0);
            SetTabCurrent(MTyp2Txt,type2);
            MixCheckType2Doubles(type2);
         }
         // mlist.txt update -- compare new mlist.txt with type2.txt
         if (MListBox->Checked && !CorruptDoc(mlist=LoadDocument(MListTxt)))
            MixCheckListKeyNotFound(mlist,type2);
      }
      // test cyberpunk documents
      if (CListBox->Checked || CRingBox->Checked)
      {
         // if no pubring.asc, clear type1.list of all but disabled
         if (!FileExists(md+CRingTxt) && FileExists(md+CTyp1Txt))
            ClearTypeFile(md+CTyp1Txt); // dump all but #'s
         // pubring.asc update
         if (CRingBox->Checked && !CorruptDoc(cring=LoadDocument(CRingTxt)))
         {
            Perform(WM_SETREDRAW,0,0);
            type1 = LoadDocument(CTyp1Txt); // set tab to doc and load docmemo
            CpkAddNewRemailerKeys(cring,type1); SetTabCurrent(CRingTxt,cring);
            CpkGenType1(type1,cring);
            Perform(WM_SETREDRAW,1,0);
            SetTabCurrent(CTyp1Txt,type1);
            CpkCheckType1Doubles(type1);
         }
         // rlist.txt update -- compare new rlist.txt with type1.txt
         if (CListBox->Checked && !CorruptDoc(clist=LoadDocument(CListTxt)))
            CpkCheckListKeyNotFound(clist,type1);
      }
   }
   catch (...)
   {
      Perform(WM_SETREDRAW,1,0);
      Invalidate();
   }
}
//---------------------------------------------------------------------------
bool __fastcall THttpForm::SaveStatistics()
{
   if (!GoodTabs()) return false;
   TStrings *TxtList;
   int i,bakcopies=STATSBAKCOPIES;
   AnsiString TxtFile,mtyp2txt=MixDir()+MTyp2Txt,ctyp1txt=MixDir()+CTyp1Txt;
   // copy current docmemo to tab stringlist to get possible edits
   SetTab(TabSet->TabIndex);
   // process tabs
   for (i=0; i<Tabs->Count; i++)
   {
      if ((TxtFile=Tabs->Strings[i])=="Error" || (TxtList=TabDoc(i))==NULL)
         continue;
      if (TxtList->Text.IsEmpty())
         continue;

      if (ErrorCheck->Checked)
      {
         // special for pubring.asc, make single keyblock
         if (HasPgp() && TxtFile==CRingTxt)
            CpkKeysToBlock(TxtList);
      }

      //==Save Statistics======================================
      SaveToFileBak(TxtList,MixDir()+TxtFile,bakcopies);
      //=======================================================
/*
      if (ErrorCheck->Checked)
      {
         TStringList *typelist = new TStringList();
         if (HasMix() && (TxtFile==MRingTxt || TxtFile==MListTxt))
         {
            typelist->Text = MixGenType2();
            SaveToFileBak(typelist,MixDir()+MTyp2Txt,bakcopies);
//          if (MixType2HasDoubles() || MixListHasKeyNotFound())
//             Cancelled = true;
         }
         if ((HasPgp() && TxtFile==CRingTxt || TxtFile==CListTxt))
         {
            typelist->Text = CpkGenType1();
            SaveToFileBak(typelist,MixDir()+CTyp1Txt,bakcopies);
//          if (CpkType1HasDoubles() || CpkListHasKeyNotFound())
//             Cancelled = true;
         }
         delete typelist;
      }
*/
   }
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall THttpForm::MixCheckType2Doubles(TStrings *Type2)
{
  bool dbl=false;
  TStringList *exp = new TStringList();
  TStringList *items = new TStringList();
  items->Text = MixType2Doubles(Type2);
  if (items->Count)
  {
     exp->Add(
        s("The following keys on your mixmaster keyring appear more than once. ")+
        s("You will need to determine which is current, and disable the older key. ")
     );
     ShowRemailerDocMessage(exp,items,"",MixKeyDuplicate,this,false);
     dbl = true;
  }
  delete items;
  delete exp;
  return dbl;
}
//---------------------------------------------------------------------------
bool __fastcall THttpForm::MixCheckListKeyNotFound(TStrings *MList, TStrings *Type2)
{
   TStringList *items = new TStringList();
   TStringList *type2 = new TStringList();
   if (Type2) type2->Text = Type2->Text; else
   if (FileExists(MixDir()+MTyp2Txt)) type2->LoadFromFile(MixDir()+MTyp2Txt);

   items->Text = MixListKeyNotFound(MList,type2);
   if (items->Count)
   {
      TStringList *exp = new TStringList();
      AnsiString plu = items->Count==1 ? "" : "s";
      AnsiString mixers = items->Count==1 ? "a Mix key" : "Mix keys";
      exp->Add(
         s("There are ")+s(items->Count)+s(" remailer")+s(plu)+s(" in your ")+
         s("current mixmaster stats report (mlist.txt), for which, you ")+
         s("have no public keys. You will probably want to obtain them. ")+
         s("See Help")
      );
      ShowRemailerDocMessage(exp,items,"",MixKeyNotFound,this);
      delete exp;
   }
   delete type2;
   delete items;
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall THttpForm::CpkCheckType1Doubles(TStrings *Type1)
{
  bool ok=false;
  TStringList *exp = new TStringList();
  TStringList *dbls = new TStringList();
  dbls->Text = CpkType1Doubles(Type1);
  if (dbls->Count)
  {
     exp->Add(
        s("The following keys on your cyberpunk keyring appear more than once. ")+
        s("You will need to determine which is current, and disable the older key. ")
     );
     ShowRemailerDocMessage(exp,dbls,"",CpkKeyDuplicate,this,false);
     ok = true;
  }
  delete dbls;
  delete exp;
  return ok;
}
//---------------------------------------------------------------------------
bool __fastcall THttpForm::CpkCheckListKeyNotFound(TStrings *CList, TStrings *Type1)
{
   TStringList *items = new TStringList();
   TStringList *type1 = new TStringList();
   if (Type1) type1->Text = Type1->Text;
   else if (FileExists(MixDir()+CTyp1Txt)) type1->LoadFromFile(MixDir()+CTyp1Txt);
   items->Text = CpkListKeyNotFound(CList,type1);
   if (items->Count)
   {
      TStringList *exp = new TStringList();
      if (items->Count==1)
         exp->Add(
            s("There is 1 remailer in your current cyberpunk stats report ")+
            s("(rlist.txt), for which, you have no public key. You will probably ")+
            s("want to obtain it. See--Help")
         );
      else
         exp->Add(
            s("There are ")+s(items->Count)+s(" remailers in your ")+
            s("current cyberpunk stats report (rlist.txt), for which, you ")+
            s("have no public keys. You will probably want to obtain them. ")+
            s("See--Help")
      );
      ShowRemailerDocMessage(exp,items,"",CpkKeyNotFound,this);
      delete exp;
   }
   delete type1;
   delete items;
   return true;
}
//---------------------------------------------------------------------------
int __fastcall THttpForm::GoodTabs()
{
   int valtabs=0;
   for (int i=0; i<Tabs->Count; i++)
   {
      TStrings *doc = dynamic_cast<TStrings*>(Tabs->Objects[i]);
      if (doc && doc->Count && doc->Text.Pos(CorruptReport)==1) continue;
      if (Tabs->Strings[i]=="Error") continue;
      valtabs++;
   }
   return valtabs;
}
//---------------------------------------------------------------------------
TStrings* __fastcall THttpForm::TabDoc(int Index)
{
   // returns doc from tab or null if corrupt
   if (Index<0 || Index>=Tabs->Count) return NULL;
   TStrings *Doc = dynamic_cast<TStrings*>(Tabs->Objects[Index]);
   if (Doc && Doc->Count && Doc->Text.Pos(CorruptReport)==1)
      Doc = NULL;
   return Doc;
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::SetTab(int TabIndex)
{
   if (TabSet->TabIndex>=0) // make sure tabdoc = docmemo
   {
      TStrings *tabdoc = dynamic_cast<TStrings*>(Tabs->Objects[TabSet->TabIndex]);
      if (tabdoc) tabdoc->Text = DocMemo->Lines->Text;
   }
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::Timer2Timer(TObject *Sender)
{
   Timer2->Enabled = false;
   GetBtnClick();
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::FormShow(TObject *Sender)
{
   GetAppURLs();
   ActiveControl = Panel2;
   if (!Attended)
   {
      PageControl1->ActivePage = TabSheet3;
      Application->ProcessMessages();
      Timer2->Enabled = true;
   }
}
//---------------------------------------------------------------------------
AnsiString KeyRingCnt(int val)
{
   AnsiString v=AnsiString(val);
   if (v.Length()<2) v = " "+v; return v;
}
//---------------------------------------------------------------------------
bool __fastcall THttpForm::CRingOk(TStrings *Doc)
{
   int beg=0,end=0;
   for (int i=0; i<Doc->Count; i++)
   {
      AnsiString line=Doc->Strings[i].Trim();
      if (line=="-----BEGIN PGP PUBLIC KEY BLOCK-----") beg++; else
      if (line=="-----END PGP PUBLIC KEY BLOCK-----") end++;
   }
   if (!beg || !end || beg!=end)
   {
      TabSet->TabIndex = Tabs->IndexOf(MRingTxt);
      DocMemo->Lines->Insert(0,CorruptReport);
      SetTab(TabSet->TabIndex);
      AppProcessMessages(); Sleep(300);
      MsgBoxHwnd(Handle,
         s("==============DOCUMENT ERROR==============\n")+
         s("\nThis 'pubring.asc' document appears corrupt. By my\n")+
         s("count there are:\n\n")+
         s(" "+KeyRingCnt(beg)+" Begin Pgp Public Key block lines\n")+
         s(" "+KeyRingCnt(end)+" End Pgp Public Key lines\n\n")+
         s("These values should BOTH be greater than 0 and equal.\n")+
         s("In most cases there will be 1 of each--that is, a single\n")+
         s("large key block containing all the cpunk keys. A few key\n")+
         s("sources provide these keys as a series of individual key\n")+
         s("blocks.\n\n")+
         s("Please have a look for yourself. You may need to update\n")+
         s("from another source. This document has been marked\n")+
         s("so you can't accidentally save it. \n \n \n"),
         MRingTxt.LowerCase(),
         MB_OK);
      return false;
   }
   if (!HasPgp()) return true;

   TStringList *newkeys = new TStringList();
   newkeys->Text = CpkGetNewRemailerKeys(Doc);
   newkeys->Sorted = true;
   // notify of new keys, if any
   // notify of new keys, if any
   if (newkeys->Count)
   {
      TStringList *msg = new TStringList();
      TStringList *rems = new TStringList();
      AnsiString s = newkeys->Count==1 ? "" : "s";
      TabSet->TabIndex = Tabs->IndexOf(CRingTxt);
      AppProcessMessages(); Sleep(300);

      msg->Add(
        s("The following "+s(newkeys->Count)+" new key"+s+" will ")+
        s("be added to your Cyberpunk keyring. Any remaining keys ")+
        s("will be discarded.")
      );
      for (int k=0; k<newkeys->Count; k++)
         rems->Add(newkeys->Strings[k]);

      ShowRemailerDocMessage(msg,rems,"",CpkKeyNew,this);
      Application->ProcessMessages();
      Sleep(500);
      delete rems;
      delete msg;
   }
   delete newkeys;
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall THttpForm::CListOk(TStrings *Doc)
{
   AnsiString statsheader =
      s("remailer  email address                        history  latency  uptime\r\n")+
      s("-----------------------------------------------------------------------\r\n");
   int i,pos;
   while ((pos=Doc->Text.Pos("&lt;"))>0) Doc->Text.Delete(pos,4);
   while ((pos=Doc->Text.Pos("&gt;"))>0) Doc->Text.Delete(pos,4);
   if (Doc->Text.Pos(statsheader)==0)
   {
      TabSet->TabIndex = Tabs->IndexOf(CListTxt);
      DocMemo->Lines->Insert(0,CorruptReport);
      SetTab(TabSet->TabIndex);
      AppProcessMessages(); Sleep(100);
      MsgBoxHwnd(Handle,
         s("==============DOCUMENT ERROR==============\n")+
         s("\nThis 'rlist.txt' document appears corrupt. I'm unable to\n")+
         s("locate the statistics column headings. They should look\n")+
         s("like this:\n\n")+
         s("\"remailer  email address                        history  latency  uptime\"\n\n")+
         s("Please have a look for yourself. You may need to update\n")+
         s("from another source. This document has been marked\n")+
         s("so you can't accidentally save it. \n \n \n"),
         CListTxt.LowerCase(),
         MB_OK
      );
      return false;
   }
   int c=0;
   for (i=0; i<Doc->Count; i++)
      if (CpkListLineOk(Doc->Strings[i])) c++;
   if (!c)
   {
      TabSet->TabIndex = Tabs->IndexOf(CListTxt);
      DocMemo->Lines->Insert(0,CorruptReport);
      SetTab(TabSet->TabIndex);
      AppProcessMessages(); Sleep(300);
      MsgBoxHwnd(Handle,
         s("==============DOCUMENT ERROR==============\n")+
         s("\nThis 'rlist.txt' document appears corrupt. I've located\n")+
         s("the stats column headers, but found no actual stats lines\n")+
         s("at all.\n\n")+
         s("Please have a look for yourself. You may need to update\n")+
         s("from another source. This document has been marked\n")+
         s("so you can't accidentally save it. \n \n \n"),
         CListTxt.LowerCase(),
         MB_OK
      );
      return false;
   }
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall THttpForm::MixListOk(TStrings *Doc)
{
   AnsiString statsheader =
      s("mixmaster           history  latency  uptime\r\n")+
      s("--------------------------------------------\r\n");
   if (Doc->Text.Pos(statsheader)==0)
   {
      TabSet->TabIndex = Tabs->IndexOf(MListTxt);
      DocMemo->Lines->Insert(0,CorruptReport);
      SetTab(TabSet->TabIndex);
      AppProcessMessages(); Sleep(300);
      MsgBoxHwnd(Handle,
         s("==============DOCUMENT ERROR==============\n")+
         s("\nThis 'mlist.txt' document appears corrupt. I'm unable to\n")+
         s("locate the statistics column headings. They should look\n")+
         s("like this:\n\n")+
         s("\"mixmaster           history  latency  uptime\"\n\n")+
         s("Please have a look for yourself. You may need to update\n")+
         s("from another source. This document has been marked\n")+
         s("so you can't accidentally save it. \n \n \n"),
         MListTxt.LowerCase(),
         MB_OK
      );
      return false;
   }
   int c=0;
   for (int i=0; i<Doc->Count; i++)
      if (MixListLineOk(Doc->Strings[i])) c++;
   if (!c)
   {
      TabSet->TabIndex = Tabs->IndexOf(MListTxt);
      DocMemo->Lines->Insert(0,CorruptReport);
      SetTab(TabSet->TabIndex);
      AppProcessMessages(); Sleep(300);
      MsgBoxHwnd(Handle,
         s("==============DOCUMENT ERROR==============\n")+
         s("\nThis 'mlist.txt' document appears corrupt. I've located\n")+
         s("the stats column headers, but found no actual stats lines\n")+
         s("at all.\n\n")+
         s("Please have a look for yourself. You may need to update\n")+
         s("from another source. This document has been marked\n")+
         s("so you can't accidentally save it. \n \n \n"),
         MListTxt.LowerCase(),
         MB_OK
      );
      return false;
   }
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall THttpForm::MixRingOk(TStrings *Doc)
{
   int i,beg=0,end=0;
   AnsiString line,descrip,s;
   TStringList *des = new TStringList();
   for (i=0; i<Doc->Count; i++)
   {
      line = Doc->Strings[i];
      if (line=="-----Begin Mix Key-----") beg++; else
      if (line=="-----End Mix Key-----") end++; else
      if (MixRingLineOk(line)) des->Add(line);
   }
   if (!(des->Count>0 && des->Count==beg && beg==end))
   {
      TabSet->TabIndex = Tabs->IndexOf(MRingTxt);
      DocMemo->Lines->Insert(0,CorruptReport);
      SetTab(TabSet->TabIndex);
      AppProcessMessages(); Sleep(300);
      MsgBoxHwnd(Handle,
         s("==============DOCUMENT ERROR==============\n")+
         s("\nThis 'pubring.mix' document appears corrupt. By my\n")+
         s("count there are:\n\n")+
         s(" "+KeyRingCnt(des->Count)+" VALID Mix key description lines\n")+
         s(" "+KeyRingCnt(beg)+" Begin Mix Key lines\n")+
         s(" "+KeyRingCnt(end)+" End Mix Key lines\n\n")+
         s("These values should ALL be greater than 0 and equal.\n\n")+
         s("Please have a look for yourself. You may need to update\n")+
         s("from another source. This document has been marked\n")+
         s("so you can't accidentally save it. \n \n \n"),
         MRingTxt.LowerCase(),
         MB_OK);
       delete des;
      return false;
   }
   delete des;

   // doc is ok, check for new keys
   TStringList *newkeys = new TStringList();
   newkeys->Text = MixGetNewRemailerKeys(Doc);
   newkeys->Sorted = true;
   // notify of new keys, if any
   if (newkeys->Count)
   {
      TStringList *msg = new TStringList();
      TStringList *rems = new TStringList();
      s = newkeys->Count==1 ? "" : "s";
      TabSet->TabIndex = Tabs->IndexOf(MRingTxt);
      AppProcessMessages(); Sleep(300);
      msg->Add(
        s("The following "+s(newkeys->Count)+" new key"+s+" will ")+
        s("be added to your Mixmaster keyring. Any remaining keys ")+
        s("will be discarded.")
      );
      for (i=0; i<newkeys->Count; i++)
      {
         descrip = "";
         for (int f=0; f<5; f++)
             if (f!=2) descrip += "  "+GetParam(f,newkeys->Strings[i]," ");
         rems->Add(descrip.Trim());
      }
      ShowRemailerDocMessage(msg,rems,"",MixKeyNew,this);
      Application->ProcessMessages();
      Sleep(500);
      delete rems;
      delete msg;
   }
   delete newkeys;
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall THttpForm::GetStatistics(AnsiString &forURL, TCheckBox *Box,
   AnsiString &Doc)
{
   CurDoc = Doc;
   CurBox = Box;
   Cap = forURL;//+"...";
   Label1->Caption = Cap;
   //CancelBtn->Caption = "Cancel";
   HttpCli1->URL = forURL;
   HttpCli1->Proxy = ProxyHostEdit->Text;
   HttpCli1->ProxyPort = ProxyPortEdit->Text;
   HttpCli1->ProxyUsername = ProxyUserEdit->Text;
   HttpCli1->ProxyPassword = ProxyPswdEdit->Text;
   HttpCli1->ModifiedSince = 0;
   ProgressBar1->Position = 0;
   ProgressBar1->Visible = true;
   BytesReceived = 0;

   try {
       HttpCli1->HeadASync();
   } __except (TRUE) {
       GetDocs->Enabled = true; //SetButtonState(true);
       TabSheet1->Enabled = true;
       TabSheet2->Enabled = true;

       DocMemo->Clear();
       DocMemo->Lines->Add("Head Failed !");
       DocMemo->Lines->Add("Status = " + IntToStr(HttpCli1->StatusCode));
       DocMemo->Lines->Add("Reason = " + HttpCli1->ReasonPhrase);
       PageControl1->ActivePage = TabSheet3;
       ProgressBar1->Visible = false;
       return false;
   }
   return !Cancelled;
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::LoadHttpInfo()
{
   TStringList *http = new TStringList();
   if (AppDataExists(HttpInfo,http))
   {
      MListBox->Checked = http->Values["MListChkd"] == "1";
      MRingBox->Checked = http->Values["MRingChkd"] == "1";
      MTyp2Box->Checked = http->Values["MTyp2Chkd"] == "1";
      CListBox->Checked = http->Values["CListChkd"] == "1";
      CRingBox->Checked = http->Values["CRingChkd"] == "1";
      ProxyHostEdit->Text = http->Values["ProxyHost"];
      ProxyPortEdit->Text = http->Values["ProxyPort"];
      ProxyPswdEdit->Text = http->Values["ProxyPswd"];
      ProxyUserEdit->Text = http->Values["ProxyUser"];
   }
   Http = http->Text; // keep for later compare to see if modified
   delete http;
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::StoreHttpInfo()
{
   TStringList *http = new TStringList();
   http->Add("MListChkd="+AnsiString(MListBox->Checked?"1":"0"));
   http->Add("MRingChkd="+AnsiString(MRingBox->Checked?"1":"0"));
   http->Add("MTyp2Chkd="+AnsiString(MTyp2Box->Checked?"1":"0"));
   http->Add("CListChkd="+AnsiString(CListBox->Checked?"1":"0"));
   http->Add("CRingChkd="+AnsiString(CRingBox->Checked?"1":"0"));
   http->Add("ProxyHost="+ProxyHostEdit->Text);
   http->Add("ProxyPort="+ProxyPortEdit->Text);
   http->Add("ProxyPswd="+ProxyPswdEdit->Text);
   http->Add("ProxyUser="+ProxyUserEdit->Text);
   if (Http!=http->Text) // test for modified
      PutAppData(HttpInfo,http);
   delete http;
}
//---------------------------------------------------------------------------
bool __fastcall THttpForm::Execute(bool attended)
{
   Attended = attended; ShowModal();
   return ModalResult==mrOk;
}
//---------------------------------------------------------------------------
//void __fastcall THttpForm::SetButtonState(bool enabled)
//{
//   GetBtn->Enabled = enabled;
//}
//---------------------------------------------------------------------------
void __fastcall THttpForm::ResetCheckboxes()
{
   Timer1->Enabled = false;
   if (MListBox->Checked) MListBox->Enabled = true;
   if (MRingBox->Checked) MRingBox->Enabled = true;
   if (MTyp2Box->Checked) MTyp2Box->Enabled = true;
   if (CListBox->Checked) CListBox->Enabled = true;
   if (CRingBox->Checked) CRingBox->Enabled = true;
   if (Attended) GetDocs->Enabled = true; //SetButtonState(true);
   TabSheet1->Enabled = true;
   TabSheet2->Enabled = true;
   Cancelled = false;
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::HttpCli1DocBegin(TObject *Sender)
{
   BytesReceived = 0;
   ProgressBar1->Position = 0;
   if (HttpCli1->RcvdStream) delete HttpCli1->RcvdStream;
   HttpCli1->RcvdStream = new TMemoryStream();
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::HttpCli1DocData(TObject *Sender, Pointer Buffer, int Len)
{
   if (BytesTotal>0)
   {
      BytesReceived += Len;
      ProgressBar1->Position = (BytesReceived/BytesTotal)*100;
      Sleep(200);
   }
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::HttpCli1DocEnd(TObject *Sender)
{
   ProgressBar1->Position = 0;
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::HttpCli1RequestDone(TObject *Sender,
	THttpRequest RqType, WORD Error)
{
   TStringList *tmp;
   AnsiString s,TxtFile;
   if (Error)
   {
      //GetBtn->Caption = "Done";
      PageControl1->ActivePage = TabSheet3;
      TStringList *tmp = new TStringList();
      tmp->Add("HTTP Error = "+AnsiString(Error));
      tmp->Add("HTTP Reason = "+HttpCli1->ReasonPhrase);
      TabSet->Tabs->AddObject("Error",tmp);
      TabSet->TabIndex = TabSet->Tabs->Count-1;
      DocMemo->Lines->Text = tmp->Text;
//    while (TabSet->Tabs->Count)
//    {
//       DocMemo->Clear();
//       TStringList *tmp = (TStringList*)TabSet->Tabs->Objects[0];
//       TabSet->Tabs->Delete(0);
//       delete tmp;
//    }
      UrlsBtn->Enabled = true;
      return;
   }
   switch (RqType)
   {
      case httpHEAD:
      {
         //sm(HttpCli1->RcvdHeader->Text);
         for (int i=0; i<HttpCli1->RcvdHeader->Count; i++)
         {
            s = HttpCli1->RcvdHeader->Strings[i];
            if (s.Pos("Content-Length: ")==1)
               BytesTotal = s.SubString(17,16).ToIntDef(0);
         }
         HttpCli1->GetASync();
         break;
      }
      case httpGET:
      {
         tmp = new TStringList();
         HttpCli1->RcvdStream->Seek(0,soFromBeginning);
         tmp->LoadFromStream(HttpCli1->RcvdStream);
         int idx = TabSet->Tabs->IndexOf(CurDoc);
         if (idx>=0)
         {  // this is already downloaded & needs to be replaced
            TStringList *old = (TStringList*)TabSet->Tabs->Objects[idx];
            TabSet->Tabs->Objects[idx] = (TObject*)tmp;
            delete old;
         }
         else
         {  // new doc
            TabSet->Tabs->AddObject(CurDoc,tmp);
            idx = TabSet->Tabs->Count-1;
         }
         TabSet->TabIndex = idx;
         // handle html
         AnsiString doc = tmp->Text.UpperCase();
         if (doc.Pos("<HTML>") && doc.Pos("<PRE>") && doc.Pos("</PRE>"))
         {
            while (tmp->Count && tmp->Strings[0].UpperCase().Trim()!="<PRE>")
               tmp->Delete(0); if (tmp->Count) tmp->Delete(0);
            while (tmp->Count && tmp->Strings[tmp->Count-1].UpperCase().Trim()!="</PRE>")
               tmp->Delete(tmp->Count-1);
            if (tmp->Count) tmp->Delete(tmp->Count-1);
         }
         // get rid of stupid banner  << these may make a bogus report empyt
         if (CurDoc==CListTxt && tmp->Text.Pos("$remailer{"))
            while (tmp->Count && !tmp->Strings[0].Pos("$remailer{"))
               tmp->Delete(0);
         // get rid of stupid remailer banner
         if (CurDoc==MListTxt && tmp->Text.Pos("Last update: "))
           while (tmp->Count && !tmp->Strings[0].LowerCase().Pos("last update: "))
              tmp->Delete(0);
         // set document
         DocMemo->Lines->Text = tmp->Text;
         DocMemo->SelStart = 0;
         CurBox->Enabled = false;
         Label1->Caption = "";
         Application->ProcessMessages();
         Sleep(100);
         // test validity of documents...
         GetBtnClick();
         delete HttpCli1->RcvdStream;
         HttpCli1->RcvdStream = NULL;
         break;
      }
   }
}
//---------------------------------------------------------------------------
AnsiString __fastcall THttpForm::GetDefaultURL(AnsiString &path)
{
   AnsiString URL;
   TStringList *urls = new TStringList(); GetAppData(urls,path);
   if (urls->Count) URL = urls->Strings[0];
   delete urls;
   return URL;
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::GetAppURLs()
{
   if ((MListURL = GetDefaultURL(StatsURLs+PS+MListTxt))=="") {
      MListBox->Checked=false; MListBox->Enabled=false;
   } else MListBox->Enabled=true;

   if ((MRingURL = GetDefaultURL(StatsURLs+PS+MRingTxt))=="") {
      MRingBox->Checked=false; MRingBox->Enabled=false;
   } else MRingBox->Enabled=true;

   if ((MTyp2URL = GetDefaultURL(StatsURLs+PS+MTyp2Txt))=="" || ErrorCheck->Checked) {
      MTyp2Box->Checked=false; MTyp2Box->Enabled=false;
   } else MTyp2Box->Enabled=true;

   if ((CListURL = GetDefaultURL(StatsURLs+PS+CListTxt))=="") {
      CListBox->Checked=false; CListBox->Enabled=false;
   } else CListBox->Enabled=true;

   if ((CRingURL = GetDefaultURL(StatsURLs+PS+CRingTxt))=="") {
      CRingBox->Checked=false; CRingBox->Enabled=false;
   } else CRingBox->Enabled=true;
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::CancelBtnClick(TObject *Sender)
{
   Timer1->Enabled = false; Label1->Caption = "";
   OkBtn->Enabled = true;
   Attended = true;
   if (!GetDocs->Enabled)
   {
      GetDocs->Enabled = true;
      TabSheet1->Enabled = true;
      TabSheet2->Enabled = true;
      CancelAnyway = true;
      HttpCli1->Abort();
      Attended = true;
      return;
   }
   ModalResult = mrCancel;
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::Timer1Timer(TObject *Sender)
{
   if (Label1->Caption=="") Label1->Caption = Cap; else Label1->Caption = "";
   Application->ProcessMessages();
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::ProxyPswdBoxClick(TObject *Sender)
{
   if (!ProxyPswdBox->Checked)
      ProxyPswdEdit->PasswordChar = '\0';
   else
      ProxyPswdEdit->PasswordChar = '*';
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::PageControl1Changing(TObject *Sender,
  bool &AllowChange)
{
   if (PageControl1->ActivePage==TabSheet3)
      ActiveControl = DocMemo;
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::UrlsBtnClick(TObject *Sender)
{
   ManageURLs(this,ErrorCheck->Checked);
   GetAppURLs();
}
//---------------------------------------------------------------------------
#define TABSTRINGS(i) ((TStrings*)TabSet->Tabs->Objects[i])
void __fastcall THttpForm::TabSetChange(TObject *Sender, int NewTab,
   bool &AllowChange)
{
   bool locked=LockWindowUpdate(Handle);
   int idx = TabSet->TabIndex;
   if (idx>=0) TABSTRINGS(idx)->Text = DocMemo->Lines->Text;
   DocMemo->Lines->Text = TABSTRINGS(NewTab)->Text;
   DocMemo->SelStart = 0;
   if (locked) LockWindowUpdate(0);
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::FormResize(TObject *Sender)
{
   CancelBtn->Left = Width - 95;
   OkBtn->Left = Width - 179;
   GetDocs->Left = Width - 265;
   ProgressBar1->Width = Width - 297;
   Label1->Top = Height - 74;
   Label1->Width = Width - 42;//ProgressBar1->Left+(ProgressBar1->Width/2)-(Label1->Width/2);
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::ErrorCheckClick(TObject *Sender)
{
  if (ErrorCheck->Checked)
  {
     MTyp2Box->Checked = false; MTyp2Box->Enabled = false;
     CTyp1Box->Visible = true;
  }
  else
  {
     CTyp1Box->Visible = false;
     MTyp2Box->Enabled = true;
  }
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::RemHlpBtnClick(TObject *Sender)
{
   AnsiString sections="Remailer\nRemailerUrl";
   if (ErrorCheck->Checked)
   {
      sections += "\nRemailerError";
      if (HasMix()) sections += "\nUpdateMixDocs";
      if (HasPgp()) sections += "\nUpdateCpkDocs";
      if (GetAppIni(StatsErrCheck,"").ToIntDef(1)) sections += "\nRemailerClear";
   }
   OpenHelp(sections,"Remailers & Remailer Documents","Remailer Dialog",Application->MainForm);
}
//---------------------------------------------------------------------------

void __fastcall THttpForm::CRingBoxClick(TObject *Sender)
{
   if (CRingBox->Checked) CListBox->Checked = true;
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::MRingBoxClick(TObject *Sender)
{
   if (MRingBox->Checked) MListBox->Checked = true;
}
//---------------------------------------------------------------------------
