#define _WINSOCKAPI_
//---------------------------------------------------------------------------
#ifndef HttpDlgH
#define HttpDlgH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ExtCtrls.hpp>
#include <HttpProt.hpp>
#include <vcl\ComCtrls.hpp>
#include <vcl\Tabs.hpp>
#include "explbtn.hpp"
#include <vcl\Buttons.hpp>
//---------------------------------------------------------------------------
bool  __fastcall GetRemailerStats(TForm *parent, bool attended=true);

class THttpForm : public TForm
{
__published:	// IDE-managed Components
 	 THttpCli *HttpCli1;
   TPanel *Panel2;
   TProgressBar *ProgressBar1;
  TButton *GetDocs;
   TButton *CancelBtn;
   TTimer *Timer1;
   TTimer *Timer2;
   TPanel *Panel1;
   TPageControl *PageControl1;
   TTabSheet *TabSheet1;
   TGroupBox *MixmasterGrp;
   TCheckBox *MTyp2Box;
   TCheckBox *MRingBox;
   TCheckBox *MListBox;
   TGroupBox *CyberpunkGrp;
   TCheckBox *CRingBox;
   TCheckBox *CListBox;
   TButton *UrlsBtn;
   TTabSheet *TabSheet2;
   TLabel *Label2;
   TLabel *Label3;
   TLabel *Label4;
   TLabel *Label5;
   TLabel *Label6;
   TEdit *ProxyHostEdit;
   TEdit *ProxyPortEdit;
   TEdit *ProxyPswdEdit;
   TEdit *ProxyUserEdit;
   TCheckBox *ProxyPswdBox;
   TTabSheet *TabSheet3;
   TTabSet *TabSet;
   TLabel *Label1;
   TButton *OkBtn;
   TTabSheet *TabSheet4;
   TGroupBox *MixErrorGrp;
   TCheckBox *MixSyncTyp2Box;
   TCheckBox *MixRepNewBox;
   TCheckBox *MixUpdRingBox;
   TGroupBox *CpunkErrorGrp;
   TCheckBox *CpunkUpdRingBox;
   TCheckBox *CpunkErrorCheck;
   TCheckBox *MixErrorCheck;
   TCheckBox *CpunkRepNewBox;
   TCheckBox *MixListBox;
   TCheckBox *MixRingBox;
   TCheckBox *MixTyp2Box;
   TLabel *Label8;
   TCheckBox *CpunkListBox;
   TCheckBox *CpunkRingBox;
   TLabel *Label9;
   TLabel *Label10;
   TLabel *Label11;
   TLabel *Label12;
   TLabel *Label13;
   TButton *Button1;
   TCheckBox *CpunkSyncTyp1Box;
   TCheckBox *CpunkTyp1Box;
   TBitBtn *BitBtn2;
   TCheckBox *ErrorCheck;
   TRichEdit *DocMemo;
   TCheckBox *CTyp1Box;
   TButton *Button2;
   TRichEdit *RichEdit1;
	 void __fastcall GetDocsClick(TObject *Sender);
	 void __fastcall HttpCli1DocBegin(TObject *Sender);
	 void __fastcall HttpCli1DocEnd(TObject *Sender);
	 void __fastcall HttpCli1RequestDone(TObject *Sender, THttpRequest RqType, WORD Error);
   void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
   void __fastcall HttpCli1DocData(TObject *Sender, Pointer Buffer, int Len);
   void __fastcall CancelBtnClick(TObject *Sender);
   void __fastcall Timer1Timer(TObject *Sender);
   void __fastcall ProxyPswdBoxClick(TObject *Sender);
   void __fastcall PageControl1Changing(TObject *Sender, bool &AllowChange);
   void __fastcall Timer2Timer(TObject *Sender);
   void __fastcall FormShow(TObject *Sender);
   void __fastcall UrlsBtnClick(TObject *Sender);
   void __fastcall TabSetChange(TObject *Sender, int NewTab, bool &AllowChange);
   void __fastcall FormResize(TObject *Sender);
   void __fastcall ErrorCheckClick(TObject *Sender);
   void __fastcall RemHlpBtnClick(TObject *Sender);
   void __fastcall CRingBoxClick(TObject *Sender);
   void __fastcall MRingBoxClick(TObject *Sender);
private:	// User declarations
public:		// User declarations
   TStrings *Tabs;
   AnsiString CurDoc;
   TCheckBox *CurBox;
   double BytesTotal;
   long BytesReceived;
   AnsiString Cap,Http,
      MListURL,MRingURL,MTyp2URL,
      CListURL,CRingURL;
   bool Attended,Cancelled,CancelAnyway;
   __fastcall THttpForm(TComponent* Owner);
   virtual __fastcall ~THttpForm();
   void __fastcall LoadHttpInfo();
   void __fastcall StoreHttpInfo();
   bool __fastcall SaveStatistics();
//   bool __fastcall DocumentProblems();
   void __fastcall ReportDocumentsAndProblems();
   TStrings* __fastcall LoadDocument(AnsiString &DocName);
   bool __fastcall CorruptDoc(TStrings *Doc);
   bool __fastcall MixCheckType2Doubles(TStrings *Type2);
   bool __fastcall MixCheckListKeyNotFound(TStrings *MList, TStrings *Type2);
   bool __fastcall CpkCheckType1Doubles(TStrings *Type2);
   bool __fastcall CpkCheckListKeyNotFound(TStrings *CList, TStrings *Type1);
   bool __fastcall Execute(bool attended);
   void __fastcall InitCheckmarks();
   void __fastcall GetAppURLs();
   void __fastcall SetTabCurrent(AnsiString &TabName, TStrings *TabDoc);
   AnsiString __fastcall GetDefaultURL(AnsiString &path);
   bool __fastcall GetStatistics(AnsiString &forURL, TCheckBox *Box, AnsiString &Doc);
   void __fastcall ResetCheckboxes();
   int  __fastcall GoodTabs(); // tabcount of good, saveable docs
   void __fastcall SetTab(int TabIndex); // set tab's doc to docmemo text
   TStrings* __fastcall TabDoc(int Index); // if valid, tab's doc, else NULL
   void __fastcall CheckDocumentsExist();
   void __fastcall ClearDocuments();
   void __fastcall GetBtnClick();
// error checking
   bool __fastcall MixListOk(TStrings *doctxt);
   bool __fastcall MixRingOk(TStrings *doctxt);
   bool __fastcall CListOk(TStrings *doctxt);
   bool __fastcall CRingOk(TStrings *doctxt);
};

//---------------------------------------------------------------------------
extern THttpForm *HttpForm;
//---------------------------------------------------------------------------
#endif
