//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <vcl\clipbrd.hpp>
#pragma hdrstop

#include "MsgInWin.h"
#include "MsgWin.h"
#include "MBoxWin.h"
#include "FileMan.h"
#include "global.h"
#include "MixmastDlg.h"
#include "Mixmaster.h"
//#include "PassDlg.h"
#include "PGPpassEx.h"
#include "clipreply.h"
#include "pop3mail.h"
#include "savedlg.h"
#include "picboxdlg.h"
//---------------------------------------------------------------------------
#pragma link "NoteWin"
#pragma link "explbtn"
#pragma resource "*.dfm"
TMessageInWin *MessageInWin;
//---------------------------------------------------------------------------
bool __fastcall OpenMessageIn(AnsiString &MailBox, AnsiString &IndexStr)
{
   if (MailBox.IsEmpty() || IndexStr.IsEmpty()) return false;
   bool locked = LockWindowUpdate(Application->MainForm->Handle);
   MessageInWin = new TMessageInWin(MailBox,IndexStr,Application->MainForm);
   if (locked) LockWindowUpdate(0);
   return true;
}
//---------------------------------------------------------------------------
__fastcall TMessageInWin::TMessageInWin(TComponent* Owner)
  : TTextWin(Owner)
{
}
//---------------------------------------------------------------------------
__fastcall TMessageInWin::TMessageInWin(AnsiString &MailBox, AnsiString &Indexstr,
   TComponent* Owner) : TTextWin(Owner)
{
   Type = tInMessage;
   Mailbox = MailBox;
   IndexStr = Indexstr;
   DataKey = UserMailboxes+PS+Mailbox+PS+IndexStr;
   GetAppData(Editor->Lines,DataKey);
   Headers = new THeaderManager(Editor->Lines);
   HeadersBtnSet = false;
   WordWrapSet = false;
   Editor->Modified = false;
   SetEditMode(false);
   SetMessage();
}
//---------------------------------------------------------------------------
__fastcall TMessageInWin::~TMessageInWin()
{
   delete Headers;
}
//---------------------------------------------------------------------------
void __fastcall TMessageInWin::SetNoMixmaster()
{
   PGPcdecBtn->Visible = false;
   Bevel99->Visible = false;
}
//---------------------------------------------------------------------------
void __fastcall TMessageInWin::SetEditButtons(bool enable)
{
   long sel = Editor->SelLength;
   if (enable)
   {
      CutBtn->Enabled = sel;
      CopyBtn->Enabled = sel;
      PasteBtn->Enabled = Clipboard()->HasFormat(CF_TEXT);
   }
   else
   {
      PasteBtn->Enabled = false;
      CopyBtn->Enabled = false;
      CutBtn->Enabled = false;
   }
}
//---------------------------------------------------------------------------
void __fastcall TMessageInWin::SetMessage()
{
   bool locked=LockWindowUpdate(AppMainForm->Handle);
   Editor->OnSelectionChange = NULL;
   AnsiString cap=IndexStr+" ",fs=FieldSep,ic=InCode;
 //change caption to remove markers===
   for (int i=1; i<=cap.Length(); i++)
      if (cap[i]==fs[1] || cap[i]==ic[1]) cap[i]=' ';
   cap = cap.Trim();
   while (cap.Length() && cap[cap.Length()]!=' ') cap.SetLength(cap.Length()-1);
   Caption = Mailbox+": "+cap;
 //=====================================================
   FullHeaders = false;
   Editor->ReadOnly = true;
   //WordWrap->Checked = false;
   Editor->WordWrap = false;
   // handle status change
   if (GetMsgStatus(DataKey)=='N') SetMsgStatus(DataKey,' ');
   LoadMessage(Editor->Lines,FullHeaders);
   HeadersBtn->Hint = "All Headers|Show all message headers";
   //SaveMessageBtn->Enabled = false;
   Editor->Modified = false;
   Editor->SelStart = 0;
   if (!HasMix()) SetNoMixmaster();
   else
      PGPcdecBtn->Enabled =
         Editor->Lines->Text.Pos("-----BEGIN PGP MESSAGE-----")>0;
   HeadersBtn->Enabled = true;
   Editor->OnSelectionChange = EditorSelectionChange;
   if (locked) LockWindowUpdate(0);
}
//---------------------------------------------------------------------------
int eohm(TStrings *msg)
{
   int e=0; while (e<msg->Count && !msg->Strings[e].IsEmpty()) e++;
   return e;
}
//---------------------------------------------------------------------------
void __fastcall TMessageInWin::CreateReply(bool UseDialog)
{
   AnsiString TemplateName=DefaultMessage,inreplyto;
   if (UseDialog && ((TemplateName=GetMergeMessage("Reply using...",modeMessage))).IsEmpty()) return;
   if (GetMsgStatus(DataKey)==' ')
   {
      SetMsgStatus(DataKey,'R');
      inreplyto = DataKey;
   }
   ReplyToMessage(Editor->Lines,TemplateName,inreplyto);
}
//---------------------------------------------------------------------------
void __fastcall TMessageInWin::HeadersBtnClick(TObject *Sender)
{
   if (EditBtn->Down)
   {
      HeadersBtn->Down = true;
      MyBeep(MB_ICONSTOP);
      return;
   }
   bool locked = LockWindowUpdate(AppMainForm->Handle);
   FullHeaders = HeadersBtn->Down;

   if (FullHeaders) HeadersBtn->Hint = "Fewer Headers|Show minimum message headers";
   else HeadersBtn->Hint = "More Headers|Show all message headers";

   LoadMessage(Editor->Lines,FullHeaders);
   Editor->Modified = false;
   Editor->SelStart = 0;
   if (locked) LockWindowUpdate(0);
}
//---------------------------------------------------------------------------
void __fastcall TMessageInWin::ReplyBtnClick(TObject *Sender)
{
   CreateReply(true);
}
//---------------------------------------------------------------------------
void __fastcall TMessageInWin::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (Editor->Modified && !CheckSave())
   {
      CanClose = false;
      return;
   }
   if (MDIChildCount==0) SetParentButtons(false);
   ShowCurXY(false);
}
//---------------------------------------------------------------------------
bool __fastcall TMessageInWin::CheckSave()
{
   bool ok = true;
   if (Editor->Modified)
   {
      int reply = MsgBoxHwnd(Handle,"Save changes to message?",
         "Save Message",MB_YESNOCANCEL);
      switch(reply)
      {
         case IDCANCEL: ok = false; break;
         case IDYES: Save(); break;
      }
   }
   return ok;
}
//---------------------------------------------------------------------------
bool __fastcall TMessageInWin::Save()
{
   AnsiString path,spath,pgphdr;
   bool ww=Editor->WordWrap;
   bool locked=LockWindowUpdate(AppMainForm->Handle);
   if (ww) Editor->WordWrap = false;
   PutAppData(DataKey,Editor->Lines);
   if (ww) Editor->WordWrap = true;
   Editor->Modified = false;
//   Editor->SelStart = 0;
   AnsiString shomsg = Caption+" ... saved!";
   Application->MainForm->Perform(WM_SHOWSTATUS,0,(LPARAM)shomsg.c_str());
   if (locked) LockWindowUpdate(0);
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall TMessageInWin::SaveAs()
{
   // not in use--don't save incoming msg to drafts
   bool locked,ww=Editor->WordWrap,ok=false;
   AnsiString path = GetSaveMessagePathEx(UserMessages+"\n"+UserNotes,Name());
   if (!path.IsEmpty())
   {
      DataKey = path;
      locked = LockWindowUpdate(AppMainForm->Handle);
      // save message
      if (ww) Editor->WordWrap = false;
      PutAppData(DataKey,Editor->Lines);
      if (ww) Editor->WordWrap = true;
      Type = tMessage;
      SetMessage();
      Caption = GetParam(0,UserMessages+": "+GetParam(1,DataKey,PS.c_str()));
      if (locked) LockWindowUpdate(0);
      ok = true;
   }
   return ok;
}
//---------------------------------------------------------------------------
bool __fastcall TMessageInWin::SaveAsNote()
{
   bool locked,ww=Editor->WordWrap,ok=false;
   AnsiString path = GetSaveMessagePathEx(UserNotes,Name());
   if (!path.IsEmpty())
   {
      DataKey = path;
      locked = LockWindowUpdate(AppMainForm->Handle);
      // save message
      if (ww) Editor->WordWrap = false;
      PutAppData(DataKey,Editor->Lines);
      if (ww) Editor->WordWrap = true;
      Type = tMessage;
      SetMessage();
      Caption = GetParam(0,UserNotes+": "+GetParam(1,DataKey,PS.c_str()));
      if (locked) LockWindowUpdate(0);
      ok = true;
   }
   return ok;
}
//---------------------------------------------------------------------------
void __fastcall TMessageInWin::OkBtnClick(TObject *Sender)
{
//   if (!Editor->Modified || (Editor->Modified && Save()))
   Close();
}
//---------------------------------------------------------------------------
void __fastcall TMessageInWin::WordWrapClick(TObject *Sender)
{
/*   TStringList *tmp = new TStringList();
   bool locked = LockWindowUpdate(Handle);
   if (Editor->WordWrap) Editor->WordWrap = false;
   tmp->Text = Editor->Lines->Text; Editor->Clear();
   Editor->WordWrap = WordWrap->Checked;
   Editor->Lines->Text = tmp->Text;
   Editor->SelStart = 0;
   delete tmp;
   SetEditRect();
//   for (int i=0; i<32; i++) Application->ProcessMessages();
   AppProcessMessages();
   if (locked) LockWindowUpdate(0);*/
}
//---------------------------------------------------------------------------
void __fastcall TMessageInWin::EditBtnClick(TObject *Sender)
{
   SetEditMode(EditBtn->Down);
}
//---------------------------------------------------------------------------
void __fastcall TMessageInWin::LoadMessage(TStrings *msg, bool fullheaders)
{
   TStringList *tmp = new TStringList();
   GetAppData(tmp,DataKey);
   if (!fullheaders)
   {
      AnsiString hdr;
      TStringList *hdrs = new TStringList();
      TStringList *minhdrs = new TStringList();
      minhdrs->Add("Date: ");
      minhdrs->Add("From: ");
      minhdrs->Add("Comments: ");
      minhdrs->Add("To: ");
      minhdrs->Add("Cc: ");
      minhdrs->Add("Subject: ");

      Headers->HereIs(tmp);
      while (!(hdr=Headers->PopHeader()).IsEmpty())
      {
         if (minhdrs->IndexOf(hdr.SubString(1,hdr.Pos(": ")+1))>=0)
            hdrs->Add(hdr);
      }
      tmp->Delete(0);
      tmp->Insert(0,hdrs->Text);
      delete minhdrs;
      delete hdrs;
   }
   msg->Text = tmp->Text;
   delete tmp;
}
//---------------------------------------------------------------------------
void __fastcall TMessageInWin::SetEditMode(bool Editing)
{
   bool locked = LockWindowUpdate(Handle);
   if (Editing)
   {
      EditBtn->Down = false;
      HeadersBtnSet = HeadersBtn->Down;
      HeadersBtn->Down = true;
      HeadersBtn->Click();
      EditBtn->Down = true;
      ReplyBtn->Enabled = false;
      if (WordWrapSet) WordWrapSet = Editor->WordWrap;
      Editor->WordWrap = false;
      Editor->ReadOnly = false;
      Editor->Modified = false;
      HeadersBtn->Down = true;
      FullHeaders = true;
      PasteBtn->Visible = true;
      CopyBtn->Visible = true;
      CutBtn->Visible = true;
      Bevel10->Visible = true;
      PGPcdecBtn->Left = Bevel10->Left+5;
      Bevel99->Left = PGPcdecBtn->Left+PGPcdecBtn->Width+4;
   }
   else
   {
      if (CheckSave())
      {
         if (!HeadersBtnSet)
         {
            HeadersBtn->Down = false;
            HeadersBtn->Click();
         }
         ReplyBtn->Enabled = true;
         Editor->WordWrap = WordWrapSet;
         Editor->ReadOnly = true;
      }
      else
         EditBtn->Down = true;
      PasteBtn->Visible = false;
      CopyBtn->Visible = false;
      CutBtn->Visible = false;
      Bevel10->Visible = false;
      PGPcdecBtn->Left = Bevel4->Left+5;
      Bevel99->Left = PGPcdecBtn->Left+PGPcdecBtn->Width+4;
   }
   if (locked) LockWindowUpdate(0);
}
//---------------------------------------------------------------------------
AnsiString __fastcall PgpErrorStr(int errcode)
{
   AnsiString msg;
   switch (errcode)
   {
      case PGP_OK: break; // success
      case PGP_SIGOK: break; // success, and signature has been verified
      case PGP_ERR:     msg = "The message can't be read!"; break;
      case PGP_PASS:    msg = "Bad passphrase"; break;
      case PGP_NOMSG:   msg = "Message is not an OpenPGP message"; break;
      case PGP_SIGNKEY: msg = "Can't verify signature"; break;
      case PGP_SIGBAD:  msg = "Bad signature"; break;
      case PGP_NODATA:  msg = "Message does not contain user data."; break;
   }
   return msg;
}
//---------------------------------------------------------------------------
void __fastcall TMessageInWin::PGPcdecBtnClick(TObject *Sender)
{
   AnsiString passphrase;
   if (!PGPgetDecryptionPassphrase(passphrase)) return;

   TStringList *fullmsg = new TStringList();
   TStringList *pgpblock = new TStringList();
   GetAppData(fullmsg,DataKey);
   fullmsg->Add(""); // so inserts can be made without checks
   int i,end,start = fullmsg->IndexOf("-----BEGIN PGP MESSAGE-----");
   if (start) end = fullmsg->IndexOf("-----END PGP MESSAGE-----");
   if (start>=0 && end>start)
   {
      for (i=start; i<=end; i++)
      {
         pgpblock->Add(fullmsg->Strings[start]);
         fullmsg->Delete(start);
      }
      int errcode = 0;
      if (PgpDecryptConventional(pgpblock,passphrase,errcode)==mrOk)
      {
         pgpblock->Insert(0,"-----BEGIN PGP DECRYPTED MESSAGE-----");
         pgpblock->Add("-----END PGP DECRYPTED MESSAGE-----");
         for (i=0; i<pgpblock->Count; i++)
            fullmsg->Insert(start+i,pgpblock->Strings[i]);
         fullmsg->Delete(fullmsg->Count-1); // dump the trailing null line

         bool locked = LockWindowUpdate(Handle);
         Editor->Lines->Text = fullmsg->Text;
         Editor->Perform(EM_LINESCROLL,0,start);
         Editor->SelStart = Editor->Perform(EM_LINEINDEX,start,NULL);
         HeadersBtn->Down = true;
         EditBtn->Down = true;
         PGPcdecBtn->Enabled = false;
         if (locked) LockWindowUpdate(0);
      }
      else
      {
         MsgBoxHwnd(Handle,
           "Unable to decrypt! "+PgpErrorStr(errcode),"PGP Error",MB_OK
         );
      }
   }
   else
   {
      MsgBoxHwnd(Handle,
        AnsiString("Unable to decrypt message!\n\n")+
        AnsiString("This message has some appearances of being\n")+
        AnsiString("PGP encrypted, but I have found a problem in\n")+
        AnsiString("the beginning and/or ending PGP markers."),
       "PGP Error",MB_OK
      );
   }
   delete pgpblock;
   delete fullmsg;
}
//---------------------------------------------------------------------------
void __fastcall TMessageInWin::SaveBtnClick(TObject *Sender)
{
  TPoint cpoint,poppoint={ -2,27 };
  cpoint = OkBtn->ClientToScreen(poppoint);
  PopupMenu1->Popup(cpoint.x,cpoint.y);
}
//---------------------------------------------------------------------------
void __fastcall TMessageInWin::PopupMenu1Popup(TObject *Sender)
{
   PopupSaveItem->Enabled = Editor->Modified;
}
//---------------------------------------------------------------------------
void __fastcall TMessageInWin::PopupSaveItemClick(TObject *Sender)
{
   Save();
}
//---------------------------------------------------------------------------
void __fastcall TMessageInWin::PopupSaveasItemClick(TObject *Sender)
{
   SaveAs();
}
//---------------------------------------------------------------------------
void __fastcall TMessageInWin::TransferMessageTo(AnsiString &Boxname)
{
   if (Boxname.IsEmpty()) return;
   AnsiString NewDataKey=UserMailboxes+PS+Boxname+PS+IndexStr;
   PutAppData(NewDataKey,Editor->Lines);
   PutAppData(DataKey,NULL);
   DataKey = NewDataKey;
   Mailbox = Boxname;
   SetMessage();
}
//---------------------------------------------------------------------------
void __fastcall TMessageInWin::CopyMessageTo(AnsiString &Boxname)
{
   if (Boxname.IsEmpty()) return;
   DataKey=UserMailboxes+PS+Boxname+PS+IndexStr;
   PutAppData(DataKey,Editor->Lines);
   Mailbox = Boxname;
   SetMessage();
}
//---------------------------------------------------------------------------
void __fastcall TMessageInWin::PopupTransferItemClick(TObject *Sender)
{
   AnsiString Oldbox=Mailbox,Newbox = GetTransferBoxname("");
   if (Newbox.IsEmpty()) return;

   TransferMessageTo(Newbox);
   // check to see if boxes are on desktop
   TMailboxWin *mbw=FindOpenMailbox(Oldbox);
   if (mbw!=NULL) mbw->RefreshIndex();
   mbw=FindOpenMailbox(Newbox);
   if (mbw!=NULL) mbw->RefreshIndex();
}
//---------------------------------------------------------------------------
void __fastcall TMessageInWin::PopupCopyItemClick(TObject *Sender)
{
   AnsiString Oldbox=Mailbox,Newbox=GetTransferBoxname("");
   if (Newbox.IsEmpty()) return;

   CopyMessageTo(Newbox);
   // check to see if boxes are on desktop
   TMailboxWin *mbw=FindOpenMailbox(Newbox);
   if (mbw!=NULL) mbw->RefreshIndex();
}
//---------------------------------------------------------------------------
void __fastcall TMessageInWin::PopupDeleteItemClick(TObject *Sender)
{
   if (MsgBox("Delete this message from the QS database?","Confirm",MB_OKCANCEL)==IDOK)
   {
      Editor->Clear(); Caption=" deleting message..."; Sleep(500);
      Application->ProcessMessages();
      PutAppData(DataKey,NULL);

      TMailboxWin *mbw=FindOpenMailbox(Mailbox);
      if (mbw!=NULL) mbw->RefreshIndex();

      Editor->Modified = false;
      Close();
   }
}
//---------------------------------------------------------------------------
void __fastcall TMessageInWin::OkBtnEnter(TObject *Sender)
{
   if (!SaveBtn->HasMouse()) SaveBtn->Perform(CM_MOUSEENTER,0,NULL);
}
//---------------------------------------------------------------------------
void __fastcall TMessageInWin::OkBtnExit(TObject *Sender)
{
   if (SaveBtn->HasMouse()) SaveBtn->Perform(CM_MOUSELEAVE,0,NULL);
}
//---------------------------------------------------------------------------
void __fastcall TMessageInWin::SaveBtnEnter(TObject *Sender)
{
   if (!OkBtn->HasMouse()) OkBtn->Perform(CM_MOUSEENTER,0,NULL);
}
//---------------------------------------------------------------------------
void __fastcall TMessageInWin::SaveBtnExit(TObject *Sender)
{
   if (OkBtn->HasMouse()) OkBtn->Perform(CM_MOUSELEAVE,0,NULL);
}
//---------------------------------------------------------------------------
void __fastcall TMessageInWin::SaveMessageBtnClick(TObject *Sender)
{
   if (Save())
   {
      //SaveMessageBtn->Enabled = false;
      EditBtn->Down = false;
      EditBtn->Click();
   }
}
//---------------------------------------------------------------------------
void __fastcall TMessageInWin::EditorSelectionChange(TObject *Sender)
{
   TTextWin::EditorSelectionChange(Sender);
//   if (Editor->Modified && !SaveMessageBtn->Enabled)
//      SaveMessageBtn->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TMessageInWin::PopupMenuClick(TObject *Sender)
{
   TTextWin::PopupMenuClick(Sender);
   TMenuItem *item = dynamic_cast<TMenuItem*>(Sender);
   if (item && item->Caption=="&Word wrap this message")
   {
      bool locked = LockWindowUpdate(Handle);
      PopWordWrapItem->Checked = !PopWordWrapItem->Checked;
      if (Editor->WordWrap!=PopWordWrapItem->Checked)
      Editor->WordWrap = PopWordWrapItem->Checked;
      if (locked) LockWindowUpdate(0);
   }
}
//---------------------------------------------------------------------------
void __fastcall TMessageInWin::SaveasNote1Click(TObject *Sender)
{
   SaveAsNote();
}
//---------------------------------------------------------------------------
