#define _WINSOCKAPI_
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <vcl\clipbrd.hpp>
#pragma hdrstop

#include "MsgWin.h"
#include "MsgInWin.h"
#include "SaveDlg.h"
#include "HttpDlg.h"
#include "SmtpDlg.h"
#include "QueueDlg.h"
#include "Version.h"
#include "Mixmaster.h"
#include "MixmastDlg.h"
#include "DelGrpsDlg.h"
#include "mboxwin.h"
#include "picboxdlg.h"
#include "addrsdlg.h"
// pgp stuff
#include "pgpmail.h"
#include "PGPpassEx.h"
#include "PGPrecips.h"

#include "helpdlg.h"

const AnsiString Drafts = "Drafts";
//---------------------------------------------------------------------------
#pragma link "NoteWin"
#pragma link "explbtn"
#pragma resource "*.dfm"
TMessageWin *MessageWin;
#define SET_HELPBTN_POS MsgHelpBtn->Left = Width-70
//---------------------------------------------------------------------------
bool __fastcall OpenMessage(AnsiString &Mailbox, AnsiString &IndexStr)
{
   if (Mailbox.IsEmpty() || IndexStr.IsEmpty()) return false;
   AnsiString DataKey = UserMailboxes+PS+Mailbox+PS+IndexStr;
   TStringList *msg = new TStringList();
   GetAppData(msg,DataKey);
   MessageWin = new TMessageWin(msg,Mailbox,IndexStr,Application->MainForm);
   delete msg;
   return true;
}
//---------------------------------------------------------------------------
char __fastcall GetMsgStatus(AnsiString &DataKey)
{
   if (DataKey.Pos(UserMailboxes)!=1) return '\0';

   AnsiString Mailbox,IndexStr;
   Mailbox = GetParam(1,DataKey,PS.c_str());
   IndexStr = GetParam(2,DataKey,PS.c_str());
   if (IndexStr==HeaderText) return GetParam(3,IndexStr," ").SubString(1,1)[1];

   if (!IsNewStyle(DataKey)) return 'S';  // only outgoing is old style
   char status=IndexStr.SubString(24,1)[1];
   if (status=='i') return ' ';
   if (status=='o') return 'S';
   return status;
}
//---------------------------------------------------------------------------
bool __fastcall SetMsgStatus(AnsiString &DataKey, char status)
{
   if (DataKey.Pos(UserMailboxes)!=1) return false;

   AnsiString Mailbox,IndexStr;
   Mailbox = GetParam(1,DataKey,PS.c_str());
   IndexStr = GetParam(2,DataKey,PS.c_str());
   TMailboxWin *box=FindOpenMailbox(Mailbox);
   if (IndexStr.Length()>=24)
   {
      IndexStr[24] = status;
      RenameAppItem(DataKey,IndexStr);
      if (box) box->MailGrid->RefreshIndex();
      DataKey = UserMailboxes+PS+Mailbox+PS+IndexStr;
   }
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall IsNewStyle(AnsiString &DataKey)
{
   AnsiString idxstr = GetParam(2,DataKey,PS.c_str());
   return idxstr.SubString(23,1)==InCode || idxstr.SubString(23,1)==OutCode;
}
//---------------------------------------------------------------------------
bool __fastcall IsIncoming(AnsiString &DataKey)
{
   AnsiString idxstr = GetParam(2,DataKey,PS.c_str());
   return IsNewStyle(DataKey) && idxstr.SubString(23,1)==InCode;
}
//---------------------------------------------------------------------------
bool __fastcall CutMessageAtCutmarks(TStrings *msg)
{
   bool cut = false;
   if (msg->Text.Pos("\r\n"+CutMarks+"\r\n"))
   {
      while (msg->Count)
      {
         AnsiString line = msg->Strings[msg->Count-1];
         msg->Delete(msg->Count-1);
         if (line.TrimRight()==CutMarks) break;
      }
      cut = true;
   }
   return cut;
}
//---------------------------------------------------------------------------
/*void __fastcall LoadQSMessage(AnsiString &Mailbox, AnsiString &IndexStr,
   TStrings* Message)
{
   PutAppData(UserMailboxes+PS+Mailbox+PS+IndexStr,Message);
}
//---------------------------------------------------------------------------
void __fastcall StoreQSMessage(AnsiString &Mailbox, AnsiString &IndexStr,
   TStrings* Message)
{
   PutAppData(UserMailboxes+PS+Mailbox+PS+IndexStr,Message);
}*/
//---------------------------------------------------------------------------
__fastcall TMessageWin::TMessageWin(TComponent* Owner) : TTextWin(Owner)
{
}
//---------------------------------------------------------------------------
__fastcall TMessageWin::TMessageWin(TStrings* Message, AnsiString &mailbox,
   AnsiString &indexstr, TComponent* Owner) : TTextWin(Owner)
{
   Font->Name = GetAppIni(EdFontName,"Courier New"); // fror wrap to window
   Font->Size = GetAppIni(EdFontSize,"").ToIntDef(10);
   // fix button font affected from above assignments
   OkBtn->Font->Name = "MS Sans Serif";
   OkBtn->Font->Size = 8;
   Mailbox = mailbox;
   IndexStr = indexstr;
   if (!Mailbox.IsEmpty()) DataKey = UserMailboxes+PS+Mailbox+PS+IndexStr;
   Type = DataKey.IsEmpty() ? tNewMessage : tMessage;
   Headers = new THeaderManager(Editor->Lines);
   Editor->Lines->Text = Message->Text;
   PgpHeaderToButtons(Editor->Lines);

   PGPencBtn->Hint = !HasPgp() ?
      "PGP conventional encrypt|PGP conventional encrypt this message on queueing/sending" :
      "PGP encrypt|PGP encrypt this message on queueing/sending";
   if (!HasPgp()) SetNoPgp();

   if (!HasMix()) SetNoMixmaster();
   MessageSent = false;
   FinalFormat = false;
   SetMessage();
//   if (MessageTesting) Timer2->Enabled = true; // testing
   SET_HELPBTN_POS;
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::Timer2Timer(TObject *Sender)
{
   // strictly for testing purposes
   Timer2->Enabled = false;
   PGPencBtn->Down = true;
   OkBtn->Click();
}
//---------------------------------------------------------------------------
__fastcall TMessageWin::~TMessageWin()
{
   delete Headers;
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   TTextWin::FormCloseQuery(Sender,CanClose);
   if (!CanClose) return;

   bool locked=false;
   TMailboxWin *box=FindOpenMailbox(Mailbox);
   if (box) locked=LockWindowUpdate(box->MailGrid->Handle);
   if (!MessageSent && !InReplyTo.IsEmpty()) SetMsgStatus(InReplyTo,' ');
   if (box && locked) LockWindowUpdate(0);
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::SetNoMixmaster()
{
   PGPencBtn->Visible = false;
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::SetNoPgp()
{
   PGPsigBtn->Visible = false;
   Bevel99->Left -= 29;
}
//---------------------------------------------------------------------------
bool __fastcall TMessageWin::UpdateStatsOnSend()
{
   return Application->MainForm->Perform(WM_UPDATECHECKED,0,NULL)>0;
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::RegisterStatsUpdated()
{
   Application->MainForm->Perform(WM_UPDATECHECKED,1,NULL);
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::NewMessage()
{
   bool locked=LockWindowUpdate(Handle);
   GetAppData(Editor->Lines,DefaultMessage); SetCursor();
   PgpHeaderToButtons(Editor->Lines);
   Editor->Modified = false;
   Caption = newMessage;
   SetCursor();
   Type = tNewMessage;
   if (locked) LockWindowUpdate(0);
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::NewArticle()
{
   bool locked=LockWindowUpdate(Handle);
   GetAppData(Editor->Lines,DefaultArticle); SetCursor();
   PgpHeaderToButtons(Editor->Lines);
   Editor->Modified = false;
   Caption = newArticle;
   SetCursor();
   Type = tNewArticle;
   if (locked) LockWindowUpdate(0);
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::SetCursor()
{
   Editor->SelStart = 0;
   TStrings *msg = Editor->Lines;
   int pos,eoh = msg->Text.Pos("\r\n\r\n");
   if (eoh==0) eoh = msg->Text.Length();
   if ((pos=msg->Text.Pos(": \r\n"))>0 && pos<eoh)
      Editor->SelStart = pos+1;
   else
   if (!pos && (pos=msg->Text.Pos(": ;"))>0 && pos<eoh)
      Editor->SelStart = pos+1;
   else
   {
      Editor->SelStart = eoh;
      if (eoh < msg->Text.Length())
         Editor->SelStart = Editor->SelStart+4;
   }
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::SaveDefMessage()
{
   AnsiString pgp,s;
   // make sure first null line is actually null and not space(s)
   for (int i=0; i<Editor->Lines->Count; i++)
   {
      s = Editor->Lines->Strings[i];
      if (!s.IsEmpty() && s.Trim().IsEmpty())
      {
         Editor->Lines->Strings[i] = "";
         break;
      }
   }
   // remove trailing null lines
   while (Editor->Lines->Count && Editor->Lines->Strings[Editor->Lines->Count-1].Trim().IsEmpty())
      Editor->Lines->Delete(Editor->Lines->Count-1);
   // save message
   ButtonsToPgpHeader(Editor->Lines);
   if (PutAppData(DefaultMessage,Editor->Lines)==TOOL_OK)
   {
      Editor->Clear(); Sleep(SleepTime);
      NewMessage();
   }
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::SaveDefArticle()
{
   AnsiString pgp,s;
   // make sure first null line is actually null and not space(s)
   for (int i=0; i<Editor->Lines->Count; i++)
   {
      s = Editor->Lines->Strings[i];
      if (!s.IsEmpty() && s.Trim().IsEmpty())
      {
         Editor->Lines->Strings[i] = "";
         break;
      }
   }
   // remove trailing null lines
   while (Editor->Lines->Count && Editor->Lines->Strings[Editor->Lines->Count-1].Trim().IsEmpty())
      Editor->Lines->Delete(Editor->Lines->Count-1);
   // save message
   ButtonsToPgpHeader(Editor->Lines);
   if (PutAppData(DefaultArticle,Editor->Lines)==TOOL_OK)
   {
      Editor->Clear(); Sleep(SleepTime);
      NewArticle();
   }
}
//---------------------------------------------------------------------------
bool __fastcall TMessageWin::Save()
{
   if (Type==tNewMessage||Type==tNewArticle) return SaveAs();
   bool locked=LockWindowUpdate(Handle);

   bool ww=Editor->WordWrap;
   TStringList *lines = new TStringList();
   if (ww) Editor->WordWrap = false;
   lines->Text = Editor->Lines->Text;
   if (ww) Editor->WordWrap = true;
   ButtonsToPgpHeader(lines);
   PutAppData(DataKey,lines);
   Editor->Modified = false;
   delete lines;

   if (locked) LockWindowUpdate(0);
   ShowStatus(Caption+" ... saved");
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall TMessageWin::SaveAs()
{
   bool ok=false;
   AnsiString path = GetSaveMessagePath(UserMessages,Name());
   if (!path.IsEmpty())
   {
      bool locked = LockWindowUpdate(Handle);

      DataKey = path;
      bool ww=Editor->WordWrap;
      TStringList *lines = new TStringList();
      if (ww) Editor->WordWrap = false;
      lines->Text = Editor->Lines->Text;
      if (ww) Editor->WordWrap = true;
      ButtonsToPgpHeader(lines);
      PutAppData(DataKey,lines);
      SetMessage(false);
      // fix caption and status
      Caption = GetParam(0,UserMessages+": "+GetParam(1,DataKey,PS.c_str()));
      ShowStatus(Caption+" ... saved");
      Type = tDraft;
      delete lines;

      if (locked) LockWindowUpdate(0);
      ok = true;
   }
   return ok;
}
//---------------------------------------------------------------------------
bool __fastcall TMessageWin::SaveAsTemplate()
{
   AnsiString path,pgphdr;
   bool locked,ww=Editor->WordWrap,ok=false;

   path = GetSaveMessagePath(UserTemplates+"only",Name());
   if (!path.IsEmpty())
   {
      DataKey = path;
      TStringList *lines = new TStringList();
      // unwrap message to lines
      locked = LockWindowUpdate(Handle);
      if (ww) Editor->WordWrap = false;
      lines->Text = Editor->Lines->Text; Editor->Clear();
      if (ww) Editor->WordWrap = true;
      bool b2h = ButtonsToPgpHeader(lines);
      if (locked) LockWindowUpdate(0);
      Application->ProcessMessages(); Sleep(100);
      // save unwrapped message
      locked=LockWindowUpdate(Handle);
      PutAppData(DataKey,lines);
      // reload message
      if (b2h) lines->Delete(0);
      Editor->Lines->Text = lines->Text;
      Type = tTemplate;
      SetMessage();
      Caption = GetParam(0,DataKey,PS.c_str())+": "+GetParam(1,DataKey,PS.c_str());
      if (locked) LockWindowUpdate(0);
      ShowStatus(Caption+" ... saved");
      delete lines;
      ok = true;
   }
   return ok;
}
//---------------------------------------------------------------------------
bool __fastcall TMessageWin::CheckSave()
{
   bool ok = true;
   if (Editor->Modified)
   {
      switch (MsgBox("Your message is modified. Changes will be lost!\n\nQueue it now?",
                 "Queue Message",MB_YESNOCANCEL))
      {
         case mrYes:
            if (!Queue()) return false;
            // fall through
         case mrNo:
            Editor->Modified = false;
            Close();
            break;
         case mrCancel:
            ok = false;
            break;
      }
   }
   return ok;
}
//---------------------------------------------------------------------------
bool __fastcall TMessageWin::CheckValid()
{
   AnsiString fcc;
   if (!ValidMail())
   {
      // maybe they fcc'd to mailbox "User Mailboxes"--no good
      if ((fcc=Headers->GetDat("Fcc: "))==UserMailboxes)
      {
         MsgBox(
            AnsiString("\""+fcc+"\"is not a valid mailbox name!\n\n")+
            AnsiString("Please choose another."),
           "Message Error",
            MB_OK
         );
         return false;
      }
      // missing header info that is required
      MsgBox(
         AnsiString("Valid entries are required for 'Host', 'From'\n")+
         AnsiString("and 'To' headers."),
        "Message Error",
         MB_OK
      );
      return false;
   }
   if (HeadMan->Has("Chain: ",Editor->Lines) && !RegKeyExists(MixKey))
   {
      MsgBox(
         AnsiString("Message contains a 'Chain:' header, but\n")+
         AnsiString("Mixmaster is not installed!\n\n")+
         AnsiString("Please remove the 'Chain:' header."),
        "Message Error",
         MB_OK
      );
      return false;
   }
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall TMessageWin::ValidMail()
{
   AnsiString host,from,rcpt,fcc;
   host = Headers->GetDat("Host: ",Editor->Lines);
   from = Headers->GetDat("From: ");
   rcpt = Headers->GetDat("To: ");
   fcc  = Headers->GetDat("Fcc: ");
   bool ok = !(host=="" ||
               from=="" || from.Pos("@")<2 ||
               rcpt=="" || rcpt.Pos("@")<2 ||
               fcc.Pos(PS)>=2
   );
   return ok;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMessageWin::Name()
{
   if (Type==tDraft||Type==tTemplate) return GetParam(1,DataKey,PS.c_str()); else
   if (Type==tNewMessage) return newMessage; else
   if (Type==tNewArticle) return newArticle; else
   return ""; // tMessage,tArticle
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMessageWin::Section()
{
//   AnsiString section;
//   if (Caption!=newMessage && Caption!=newArticle)
//      section = Caption.SubString(1,Caption.Pos(":")-1);
//   return section;
   return Mailbox;
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::SetMessage(bool setcursor)
{
   Editor->OnSelectionChange = NULL;
   AnsiString cap=IndexStr+" ",fs=FieldSep,oc=OutCode;
   if (Mailbox.IsEmpty() && cap.Trim().IsEmpty())
      Caption = Headers->Get("Newsgroups: ").IsEmpty() ? newMessage:newArticle;
   else
   if (Type==tMessage || Type==tArticle)
   {
      // change caption to remove markers ===============
      if (cap.Pos(InCode)>0 || cap.Pos(OutCode)>0)
      {
         for (int i=1; i<=cap.Length(); i++)
            if (cap[i]==fs[1] || cap[i]==oc[1]) cap[i]=' ';
         cap = cap.Trim();
         while (cap.Length() && cap[cap.Length()]!=' ')
            cap.SetLength(cap.Length()-1);
      }
      // =================================================
      Caption = Mailbox+": "+cap;
   }
   if (setcursor)
   {
      Editor->SelStart = 0;
      if (Editor->Lines->Count && Editor->Lines->Strings[0].SubString(1,1)!="#")
         SetCursor();
   }
   Editor->OnSelectionChange = EditorSelectionChange;
//   SaveMessageBtn->Enabled = false;
   Editor->Modified = false;
   ShowCurXY(true);
}
//---------------------------------------------------------------------------
bool __fastcall TMessageWin::CheckMailQueue()
{
   bool check=false;
   TStringList *tmp = new TStringList();
   if (AppDataExists(MailQueue,tmp))
   {
      AnsiString S(tmp->Count>1?"s ":" "),IS(S==" "?"is":"are"),count(tmp->Count);
      int ret=MsgBoxHwnd(Handle,
         AnsiString("There "+IS+" "+count+" message"+S+"in the Mail Queue.\n\n")+
         AnsiString("Take a look, now?"),"Queued Mail",
         MB_YESNOCANCEL
      );
      switch (ret)
      {
         case IDYES: Application->MainForm->Perform(WM_OPENQUEUE,0,NULL);
         case IDCANCEL:
            check=true;
            break;
      }
   }
   delete tmp;
   return check;
}
//---------------------------------------------------------------------------
bool __fastcall TMessageWin::CheckProblemsQueue()
{
   bool check=false;
   TStringList *tmp = new TStringList();
   if (AppDataExists(ProblemQueue,tmp))
   {
      AnsiString S(tmp->Count>1?"s ":" "),IS(S==" "?"is":"are"),count(tmp->Count);
      int ret=MsgBoxHwnd(Handle,
         AnsiString("There "+IS+" "+count+" message"+S+"in the PROBLEM Queue.\n\n")+
         AnsiString("Take a look, now?"),"Previous Problems",
         MB_YESNOCANCEL
      );
      switch (ret)
      {
         case IDYES: Application->MainForm->Perform(WM_OPENPROBLEMS,0,NULL);
         case IDCANCEL:
            check=true;
            break;
      }
   }
   delete tmp;
   return check;
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::CheckWhiteEOH()
{
   for (int i=0; i<Editor->Lines->Count; i++)
   {
      AnsiString s = Editor->Lines->Strings[i];
      if (s.IsEmpty()) break;
      if (s.Length() && s.Trim().IsEmpty())
      {
         Editor->Lines->Strings[i] = "";
         break;
      }
   }
}
//---------------------------------------------------------------------------
bool __fastcall TMessageWin::CheckOver80Chars()
{
   bool ok = true;
   TStringList *hold = new TStringList();
   for (int i=0; i<Editor->Lines->Count; i++)
   {
      AnsiString s = Editor->Lines->Strings[i]; if (s.IsEmpty()) break;
      if (s.Length()<=80) { hold->Add(s); continue; }
      Editor->SelStart = hold->Text.Length();
      Editor->Perform(EM_SCROLLCARET,0,0);
      Application->ProcessMessages();
      MsgBox(
         AnsiString("  You have a header that's too long. Mixmaster allows only 80  \n")+
         AnsiString("  characters. You can probably break the header and continue it  \n")+
         AnsiString("  on the next line. I'll placed the cursor at the beginning of the\n")+
         AnsiString("  problem header. When breaking the header, make sure each  \n")+
         AnsiString("  continued line is indented with a space or a tab. \n")+
         AnsiString("\n\n"),
        "Header Length Problem",
         MB_OK
      );
      ok = false;
      break;
   }
   delete hold;
   return ok;
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::CheckReferences()
{
   int pos;
   if (!HeadMan->Has("Chain: ",Editor->Lines)) return;

   AnsiString refs = HeadMan->GetReferences();
   while (references.Length()+refs.Length() > 80)
   {
      if ((pos=refs.Pos(">"))==0) break;
      refs = refs.SubString(pos+2,1024);
   }
//   while ((pos=refs.Pos("> <"))>0) refs.Insert("\r\n",pos+1);
//   Editor->Lines->Insert(HeadMan->Delete(references),references+refs);
}
//---------------------------------------------------------------------------
bool __fastcall TMessageWin::CheckNewsgroups()
{
   int pos;
   bool ok = true;
   if (!HeadMan->Has("Chain: ",Editor->Lines)) return ok;

   AnsiString grps = HeadMan->GetNewsgroups();
   if (newsgroups.Length()+grps.Length() > 80)
   {
      if ((ok=MassageNewsgroups(grps,this))==true)
      {
         pos=0; while(++pos<grps.Length()-1)
            if (grps[pos]==',') grps.Insert("\r\n ",pos+1);
         Editor->Lines->Insert(HeadMan->Delete(newsgroups),newsgroups+grps);
      }
   }
   return ok;
}
//---------------------------------------------------------------------------
int  __fastcall TMessageWin::SendWordWrap()
{
  int wrap=0;
  if (Editor->Lines->Text.Pos("-----BEGIN PGP")>0) return wrap;

  if (GetAppIni(SendWrapWin,"")=="1")
     wrap = Editor->ClientWidth/Canvas->TextWidth("X"); else
  if (GetAppIni(SendWrapChars,"")=="1")
     wrap = GetAppIni(SendWrapCharsCount,"").ToIntDef(68);
//else if (GetAppIni(SendWrapNot,"")=="1")
//   wrap = 0;
  return wrap;
}
//---------------------------------------------------------------------------
#define IsPgp (PGPencBtn->Down || PGPsigBtn->Down)
//---------------------------------------------------------------------------
bool __fastcall TMessageWin::Queue(bool UseDialog)
{
// remove any previous error messages from top of message
//   while (Editor->Lines->Count && Editor->Lines->Strings[0].SubString(1,1)=="#")
//      Editor->Lines->Delete(0);

   CheckWhiteEOH();
   if (Limit80Chars && HeadMan->Has("Chain: ",Editor->Lines))
   {
      if (!CheckOver80Chars() || !CheckNewsgroups()) return false;
   }
   if (HasPgp() && IsPgp && !HandlePGP()) return false;
   if (CheckValid())
   {
      if (!HasPgp() && IsPgp && !HandleCPGP()) return false;
      Application->ProcessMessages(); Sleep(200);

      int SendWrap = FinalFormat?0:SendWordWrap();
      if (QueueMessage(Editor,SendWrap,UseDialog))
      {
         Application->MainForm->Perform(WM_QUEUECHANGE,0,NULL);
         Editor->Modified = false;
         if (UseDialog) {
           Sleep(200); Close();
         }
         return true;
      }
   }
   return false;
}
//---------------------------------------------------------------------------
bool __fastcall TMessageWin::Send()
{
   if (CheckProblemsQueue()) return false;
   if (UpdateStatsOnSend())
   {
      AnsiString chain=HeadMan->GetDat("Chain: ",Editor->Lines);
      if (!chain.Pos("*"))  // turn off updating when no random present
         Application->MainForm->Perform(WM_UPDATEENABLE,0,NULL);
      else
      {
         if (!GetRemailerStats(Application->MainForm,false))
            return false;
         Application->ProcessMessages();
         Sleep(500);
      }
      RegisterStatsUpdated();
   }
   if (Queue(!UseDialog))
   {
      // Send a message to the mainform letting it take
      // control--close this window, set a timer, wait, open smtpdlg
      PostMessage(Application->MainForm->Handle,WM_SENDMAIL,0,(LPARAM)this);
      MessageSent = true;
      return true;
   }
   return false;
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::QueueBtnClick(TObject *Sender)
{
   Queue();
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::OkBtnClick(TObject *Sender)
{
   Send();
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::FormResize(TObject *Sender)
{
   SetEditRect();
   SET_HELPBTN_POS;
//   PGPencBtn->Left = Panel1->Width - 82;
//   PGPsigBtn->Left = PGPencBtn->Left + 26;
//   PGPnowBtn->Left = PGPsigBtn->Left + 26;
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::FormShow(TObject *Sender)
{
   //PGPnowBtn->Enabled = PGPsigBtn->Down || PGPencBtn->Down;
   FormResize(NULL);
}
//---------------------------------------------------------------------------
// PGP stuff
//---------------------------------------------------------------------------
bool __fastcall TMessageWin::HandlePGP()
{
   bool ok=false;
   if (!PGPencBtn->Down&&!PGPsigBtn->Down) return ok;
   TStrings *msg = new TStringList(); TStrings *lines = Editor->Lines;
   if (PGPencBtn->Down&&PGPsigBtn->Down) msg->SetText(PgpEncryptSignMessage(lines->Text.c_str())); else
   if (PGPencBtn->Down) msg->SetText(PgpEncryptMessage(lines->Text.c_str())); else
   if (PGPsigBtn->Down) msg->SetText(PgpSignMessage(lines->Text.c_str()));
   if (msg->Count)
   {
      Editor->Clear(); Application->ProcessMessages();
      bool locked = LockWindowUpdate(Handle);
      Editor->Lines->Text = msg->Text; Editor->SelStart = 0;
      PGPencBtn->Down = false; PGPsigBtn->Down = false;
      ok = true; Sleep(200);
      if (locked) LockWindowUpdate(0);
   }
   delete msg;
   return ok;
}
//---------------------------------------------------------------------------
bool __fastcall TMessageWin::HandleCPGP()
{
   if (!PGPencBtn->Down) return false;
   bool ok=CEncryptMessage();
   PGPencBtn->Down = false;
   return ok;
}
//---------------------------------------------------------------------------
bool __fastcall TMessageWin::CEncryptMessage()
{
   AnsiString passphrase;
   if (!PGPgetConventionalPassphrase(passphrase,Application->MainForm)) return false;

   int mrResult=mrOk;
   // transfer unwrapped message to msg stringlist
   bool locked,ww=Editor->WordWrap;
   TStringList *msg = new TStringList();
   locked = LockWindowUpdate(Handle);
   if (ww) Editor->WordWrap = false;
   msg->Text = Editor->Lines->Text;
   if (ww) Editor->WordWrap = true;
   // find end of headers
   int idx=0; while (idx<msg->Count && !msg->Strings[idx].TrimRight().IsEmpty())
       idx++;
   if (idx>=msg->Count || !msg->Strings[idx].TrimRight().IsEmpty())
   {
      if (locked) LockWindowUpdate(0);
      MsgBoxHwnd(Application->MainForm->Handle,
         AnsiString("Your message does not appear to have an empty\n")+
         AnsiString("line between headers and body!"),
        "QS PGP Encrypt Error",MB_OK);
      ClearString(passphrase);
      delete msg;
      return NULL;
   }
   // cut-at-marks remove nulls and get body
   CutMessageAtCutmarks(msg);
   while (msg->Count && msg->Strings[msg->Count-1].Trim().IsEmpty())
      msg->Delete(msg->Count-1);
   TStringList *mail = new TStringList();
   int SendWrap = FinalFormat?0:SendWordWrap();
   while (msg->Count>idx+1)
   {
      AddString(msg->Strings[idx+1],mail,SendWrap); // wrap while adding
      msg->Delete(idx+1);
   }

   if (mail->Count)
   {
      if ((mrResult=PgpEncryptConventional(mail,passphrase))==mrOk)
      {
         Editor->Clear();
         Application->ProcessMessages(); Sleep(200);
         msg->AddStrings(mail);
         Editor->Lines->Text = msg->Text;
         Editor->SelStart = 0;
      }
   }
   else
   {
      if (locked) LockWindowUpdate(0); locked = false;
      MsgBoxHwnd(Handle,"Nothing to encrypt!","PGP Encrypt Error",MB_OK);
   }
   if (locked) LockWindowUpdate(0);
   Application->ProcessMessages();
   Sleep(200);
   delete mail;
   delete msg;
   return mrResult==mrOk;
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::LoadMessage(AnsiString &Mailname)
{
   TStringList *tmp = new TStringList();
   GetAppData(tmp,UserMailboxes+PS+Mailbox+PS+Mailname);
   PgpHeaderToButtons(tmp);
   Editor->Lines->Text = tmp->Text;
   Editor->SelStart = 0;
   Editor->Modified = false;
   delete tmp;
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::SaveMessage(AnsiString &Mailname)
{
   AnsiString pgphdr;
   TStringList *tmp = new TStringList();
   tmp->Text = Editor->Lines->Text;
   ButtonsToPgpHeader(tmp);
   PutAppData(UserMailboxes+PS+Mailbox+PS+Mailname,tmp);
   Editor->Modified = false;
   delete tmp;
}
//---------------------------------------------------------------------------
bool __fastcall TMessageWin::ButtonsToPgpHeader(TStrings *Message)
{
   if (!Message->Count) return false;
   AnsiString pgp;
   if (PGPencBtn->Down && PGPsigBtn->Down) pgp = "encrypt,sign"; else
   if (PGPencBtn->Down) pgp = "encrypt"; else
   if (PGPsigBtn->Down) pgp = "sign";
   if (pgp.Length())
   {
      Message->Insert(0,"Pgp: "+pgp);
      return true;
   }
   return false;
}
//---------------------------------------------------------------------------
bool __fastcall TMessageWin::PgpHeaderToButtons(TStrings *Message)
{
   if (!Message->Count) return false;
   AnsiString pgp=Message->Strings[0];
   if (pgp.Pos("Pgp: ")==1)
   {
      PGPencBtn->Down = pgp.Pos("encrypt");
      PGPsigBtn->Down = pgp.Pos("sign");
      Message->Delete(0);
      return true;
   }
   return false;
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::PGPencBtnClick(TObject *Sender)
{
//   PGPnowBtn->Enabled = (PGPencBtn->Down || PGPsigBtn->Down);
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::PGPsigBtnClick(TObject *Sender)
{
//   PGPnowBtn->Enabled = (PGPencBtn->Down || PGPsigBtn->Down);
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::PopFinalFormatItemClick(TObject *Sender)
{
   if (MsgBoxHwnd(Handle,"Format Message?","Confirm",MB_OKCANCEL)==IDOK)
   {
      bool locked = LockWindowUpdate(Handle);
      Editor->WordWrap = false;
      WrapMessage(Editor->Lines,SendWordWrap());
      Editor->SelStart = 0;
      FinalFormat = true;
      if (locked) LockWindowUpdate(0);
   }
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::PopupMenuClick(TObject *Sender)
{
   TTextWin::PopupMenuClick(Sender);
   if (HasPgp()) PopDoPgpItem->Enabled = PGPencBtn->Down || PGPsigBtn->Down;
   else PopDoPgpItem->Enabled = PGPencBtn->Down;

   bool editwrapwin = GetAppIni(WordWrap,"").ToIntDef(1);
   bool sendwrapwin = GetAppIni(SendWrapWin,"").ToIntDef(1);
   bool sendwrapnot = GetAppIni(SendWrapNot,"").ToIntDef(0);
   PopFinalFormatItem->Enabled =
      !(editwrapwin && sendwrapwin) && !(!editwrapwin && sendwrapnot);

/* hold these for a while
   GetAppIni(SendWrapChars,"").ToIntDef(0);
   SendWrapCharEdit->Color = checked ? clWindow:clBtnFace;
   SendWrapCharBtn->Checked = checked;
   if (!SendWrapCharBtn->Checked) SendWrapCharEdit->Enabled = false;
   SendWrapCharEdit->Text = GetAppIni(SendWrapCharsCount,"65");
   SendWrapWinBtn->Checked = GetAppIni(SendWrapWin,"").ToIntDef(1);
   SendWrapNotBtn->Checked = GetAppIni(SendWrapNot,"").ToIntDef(0);*/
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::PopDoPgpItemClick(TObject *Sender)
{
   if (HasPgp()) HandlePGP();
   else HandleCPGP();
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::SaveBtnClick(TObject *Sender)
{
  TPoint cpoint,poppoint={ -2,27 };
  cpoint = OkBtn->ClientToScreen(poppoint);
  PopupSaveMenu->Popup(cpoint.x,cpoint.y);
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::PopupSaveMenuPopup(TObject *Sender)
{
   PopupSaveItem->Enabled = Editor->Modified;
   PopupDeleteItem->Enabled = Type!=tNewMessage && Type!=tNewArticle;
   PopupTransferItem->Enabled = PopupDeleteItem->Enabled;
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::PopupSaveItemClick(TObject *Sender)
{
   Save();
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::PopupQueueMessageClick(TObject *Sender)
{
   Queue(UseDialog);
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::PopupSaveasItemClick(TObject *Sender)
{
   SaveAs();
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::PopupSaveasTemplateItemClick(TObject *Sender)
{
   SaveAsTemplate();
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::PopupSaveDefMessageItemClick(TObject *Sender)
{
   SaveDefMessage();
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::PopupSaveDefArticleItemClick(TObject *Sender)
{
   SaveDefArticle();
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::TransferMessageTo(AnsiString &Boxname)
{
   if (Boxname.IsEmpty()) return;
   if (Type!=tMessage||Type!=tArticle) IndexStr=Headers->IndexString(Editor->Lines);
   AnsiString NewDataKey=UserMailboxes+PS+Boxname+PS+IndexStr;
   TStringList *tmp = new TStringList();
   tmp->Text = Editor->Lines->Text;
   ButtonsToPgpHeader(tmp);
   PutAppData(NewDataKey,Editor->Lines);
   PutAppData(DataKey,NULL);
   DataKey = NewDataKey;
   delete tmp;
   Mailbox = Boxname;
   Type = tMessage;
   SetMessage();
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::CopyMessageTo(AnsiString &Boxname)
{
   if (Boxname.IsEmpty()) return;
   if (Type!=tMessage||Type!=tArticle) IndexStr=Headers->IndexString(Editor->Lines);
   DataKey=UserMailboxes+PS+Boxname+PS+IndexStr;
   TStringList *tmp = new TStringList();
   tmp->Text = Editor->Lines->Text;
   ButtonsToPgpHeader(tmp);
   PutAppData(DataKey,tmp);
   delete tmp;
   Mailbox = Boxname;
   Type = tMessage;
   SetMessage();
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::PopupTransferItemClick(TObject *Sender)
{
   AnsiString Oldbox=Mailbox,Newbox = GetTransferBoxname("");
   if (Newbox.IsEmpty()) return;

   TransferMessageTo(Newbox);
   // check to see if boxes are on desktop
   TMailboxWin *mbw=FindOpenMailbox(Oldbox);
   if (mbw!=NULL) mbw->RefreshIndex();
   mbw=FindOpenMailbox(Newbox);
   if (mbw!=NULL) mbw->RefreshIndex();
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::PopupCopyMessageItemClick(TObject *Sender)
{
   AnsiString Oldbox=Mailbox,Newbox=GetTransferBoxname("");
   if (Newbox.IsEmpty()) return;

   CopyMessageTo(Newbox);
   // check to see if boxes are on desktop
   TMailboxWin *mbw=FindOpenMailbox(Newbox);
   if (mbw!=NULL) mbw->RefreshIndex();
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::PopupDeleteItemClick(TObject *Sender)
{
//tNewMessage,tMessage,tNewArticle,tArticle,tNewNote,tNote,tDraft,tTemplate
   if (Type==tNewMessage||Type==tNewArticle||DataKey.IsEmpty()) return;
   AnsiString doc;
   switch (Type)
   {
      case tDraft: doc="draft"; break;
      case tMessage: doc="message"; break;
      case tArticle: doc="article"; break;
      case tTemplate: doc="template"; break;
   }
   if (MsgBox("Delete this "+doc+" from the QS database?","Confirm",MB_OKCANCEL)==IDOK)
   {
      Editor->Clear(); Caption=" deleting "+doc+"..."; Sleep(500);
      Application->ProcessMessages();
      PutAppData(DataKey,NULL);
      if (Type==tMessage||Type==tArticle)
      {
         TMailboxWin *mbw=FindOpenMailbox(Mailbox);
         if (mbw!=NULL) mbw->RefreshIndex();
      }
      Editor->Modified = false;
      Close();
   }
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::SaveMessageBtnClick(TObject *Sender)
{
//   if (Save()) SaveMessageBtn->Enabled = false;
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::EditorSelectionChange(TObject *Sender)
{
   TTextWin::EditorSelectionChange(Sender);
//   if (Editor->Modified && !SaveMessageBtn->Enabled)
//      SaveMessageBtn->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::OkBtnEnter(TObject *Sender)
{
   if (!SaveBtn->HasMouse()) SaveBtn->Perform(CM_MOUSEENTER,0,NULL);
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::OkBtnExit(TObject *Sender)
{
   if (SaveBtn->HasMouse()) SaveBtn->Perform(CM_MOUSELEAVE,0,NULL);
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::SaveBtnEnter(TObject *Sender)
{
   if (!OkBtn->HasMouse()) OkBtn->Perform(CM_MOUSEENTER,0,NULL);
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::SaveBtnExit(TObject *Sender)
{
   if (OkBtn->HasMouse()) OkBtn->Perform(CM_MOUSELEAVE,0,NULL);
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::AddrsBtnClick(TObject *Sender)
{
   AppMainForm->Perform(WM_OPENADDRESSES,0,0);
/*   TStringList *rcpts = new TStringList();
   if (GetMailRecipients(rcpts,modeAddress))
   {
      int i,pos;
      bool locked=LockWindowUpdate(Handle);
      AnsiString s,hdr = rcpts->Text.SubString(1,4).LowerCase();
      if ((pos=HeadMan->Delete(hdr,Editor->Lines))>=0)
      {
         for (i=0; i<rcpts->Count; i++)
            Editor->Lines->Insert(pos+i,rcpts->Strings[i]);
      }
      else
      {
         for (pos=0; pos<Editor->Lines->Count; pos++)
         {
            s = Editor->Lines->Strings[pos].LowerCase();
            if (s.Pos("newsgroups: ")==1 || s.Pos("subject: ")==1 || s.IsEmpty())
            {
               for (i=0; i<rcpts->Count; i++)
                  Editor->Lines->Insert(pos+i,rcpts->Strings[i]);
               break;
            }
         }
      }
      SetCursor();
      if (locked) LockWindowUpdate(0);
   }
   delete rcpts;
*/
}
//---------------------------------------------------------------------------
void __fastcall TMessageWin::MsgHelpBtnClick(TObject *Sender)
{
   AnsiString sections = "NewMessage";
   if (HasPgp()) sections += "\nNewMessagePgp";
   OpenHelp(sections,"New Messages","Introduction",Application->MainForm);
}
//---------------------------------------------------------------------------
