//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "qspgpver.h"
#include "pgprecips.h"
#include "PgpPassEx.h"
#include "pgpfiles.h"
#include "global.h"
#include "fileman.h"
#include "headman.h"
#include "pgpdlg.h"
#include "MixmastDlg.h"
#include "pgpdb.h"
#include "pgp.h"
#include "view.h"

USERES("QSPGP.res");
USEUNIT("QSpgpVer.cpp");
USEFORM("PgpRecips.cpp", PgpRecipForm);
USEFORM("Wiper.cpp", WipeForm);
USEUNIT("pgp.cpp");
USEUNIT("Global.cpp");
USEUNIT("Mixmaster.cpp");
USEUNIT("Console.cpp");
USEUNIT("Fmxutils.cpp");
USEFORM("PGPpassEx.cpp", PgpPassForm);
USEUNIT("FileMan.cpp");
USEUNIT("HeadMan.cpp");
USEFORM("MixmastDlg.cpp", MixForm);
USEFORM("PgpDlg.cpp", PgpForm);
USEUNIT("PgpFiles.cpp");
USELIB("zlib.LIB");
USEUNIT("pgpdb.cpp");
USEFORM("View.cpp", ViewDialog);
//---------------------------------------------------------------------------
extern "C" __declspec(dllexport) void __fastcall PgpInit(HINSTANCE HMixLib,
   HINSTANCE HSSLLib, TForm *MainForm, HWND AppHandle);
extern "C" __declspec(dllexport) char* __fastcall PgpSignMessage(char *Message);
extern "C" __declspec(dllexport) char* __fastcall PgpEncryptMessage(char *Message);
extern "C" __declspec(dllexport) char* __fastcall PgpEncryptSignMessage(char *Message);
// returns only _new_ keys, not keys already in rem keyring
//extern "C" __declspec(dllexport) char* __fastcall PgpGetNewRemailerKeys(char *KeyDoc);
// returns new type1.list and saves new keyring in CRingTmp
//extern "C" __declspec(dllexport) char* __fastcall PgpAddNewRemailerKeys(char *KeyDoc, char *Type1);
extern "C" __declspec(dllexport) char* __fastcall PgpGetUserIdsKeyIds(char* KeyFile);
// gets individually armored keys
extern "C" __declspec(dllexport) char* __fastcall PgpArmorBlockToArmorKeys(char *keys);
extern "C" __declspec(dllexport) char* __fastcall PgpArmorKeysToArmorBlock(char *keys);
// import/replace pgp keys
extern "C" __declspec(dllexport) bool  __fastcall PgpImportKeysReplace(char *importfile,
   char *pubring, char *secring, bool deleteimportfile);
extern "C" __declspec(dllexport) bool  __fastcall PgpImportKeysAddNew(char *importfile,
   char *pubring, char *secring, bool deleteimportfile);
// init routines
extern "C" __declspec(dllexport) char* __fastcall GetPgpLibVersion();
extern "C" __declspec(dllexport) char* __fastcall GetPgpLibName();
// utility
bool __fastcall CutMessageAtCutmarks(TStrings *msg);
// string for returning char*s
char *retbuf=NULL;
//---------------------------------------------------------------------------
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void*)
{
  return 1;
}
//---------------------------------------------------------------------------
void  __fastcall PgpInit(HINSTANCE HMixLib, HINSTANCE HSSLLib, TForm *MainForm,
   HWND AppHandle)
{
   hMixLib=HMixLib; hSSLLib=HSSLLib;
   Application->Handle=AppHandle;
   ActMainForm=MainForm;
}
//---------------------------------------------------------------------------
bool __fastcall PgpImportKeysReplace(char *importfile, char *pubring, char *secring,
   bool deleteImportfile)
{
   int bakcopies=STATSBAKCOPIES;
   AnsiString pubringtmp=s(pubring)+".tmp",secringtmp=s(secring)+".tmp";

   TPgpDB *pubdb=new TPgpDB();
   TPgpDB *secdb=new TPgpDB();
   TPgpDB *impdb=new TPgpDB(importfile);
   for (int k=0; k<impdb->keys->Count; k++)
   {
      TPgpDBKey *key = impdb->GetKey(k);
      if (key->Type()==PGP_PUBKEY) pubdb->AddKey(key); else
      if (key->Type()==PGP_SECKEY) secdb->AddKey(key);
   }
   delete impdb;

   if (pubdb->keys->Count || !FileExists(pubring))
      pubdb->SaveToFileBak(pubring,bakcopies,!Armored);
   if (secdb->keys->Count || !FileExists(pubring))
      secdb->SaveToFileBak(secring,bakcopies,!Armored);
   if (deleteImportfile) DeleteFile(importfile);
   delete secdb;
   delete pubdb;
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall PgpImportKeysAddNew(char *importfile, char *pubring, char *secring,
   bool deleteImportfile)
{
   int bakcopies = STATSBAKCOPIES;
   AnsiString pubringtmp=s(pubring)+".tmp",secringtmp=s(secring)+".tmp";

   TPgpDB *pubdb = new TPgpDB(pubring);
   TPgpDB *secdb = new TPgpDB(secring);
   TPgpDB *impdb = new TPgpDB(importfile);
   for (int k=0; k<impdb->keys->Count; k++)
   {
      TPgpDBKey *key = impdb->GetKey(k);
      if (key->Type()==PGP_PUBKEY && pubdb->Find(key)<0) pubdb->AddKey(key); else
      if (key->Type()==PGP_SECKEY && secdb->Find(key)<0) secdb->AddKey(key);
   }
   delete impdb;

   if (pubdb->keys->Count || !FileExists(pubring))
      pubdb->SaveToFileBak(pubring,bakcopies,!Armored);
   if (secdb->keys->Count || !FileExists(pubring))
      secdb->SaveToFileBak(secring,bakcopies,!Armored);
   if (deleteImportfile) DeleteFile(importfile);
   delete secdb;
   delete pubdb;
   return true;
}
//---------------------------------------------------------------------------
char* __fastcall PgpGetUserIdsKeyIds(char *KeyFile)
{
   TPgpDb *pgpdb = new TPgpDb(KeyFile,"");
   if (pgpdb->error!=0)
   {
      delete pgpdb;
      return NULL;
   }

   TStringList *ids = new TStringList();
   TPgpKey *key = pgpdb->FirstKey();
   while (key)
   {
      for (int i=0; i<key->UserIds->Count; i++)
         ids->Add(key->IdText8+"="+key->UserIds->Strings[i]);
      key = key->Next;
   }
   if ((retbuf=new char[ids->Text.Length()+1])!=NULL)
      strcpy(retbuf,ids->Text.c_str());

   delete pgpdb;
   delete ids;
   return retbuf;
}
//---------------------------------------------------------------------------
bool __fastcall InType1(AnsiString &remailer, TStrings *type1)
{
   bool ok = false;
   for (int i=0; i<type1->Count; i++)
   {
      if (type1->Strings[i]==remailer)// || type->Strings[i]=="#"+remailer)
      {
         ok = true;
         break;
      }
   }
   return ok;
}
//---------------------------------------------------------------------------
AnsiString __fastcall GetParamSpc(int pos, AnsiString fromStr)
{
   fromStr = fromStr.Trim();
   int p = fromStr.Pos(" ");
   AnsiString prm=fromStr.Trim().SubString(1,p-1);
   if (pos>0) return GetParamSpc(pos-1,fromStr.SubString(p,256));
   return prm;
}
//---------------------------------------------------------------------------
char* __fastcall PgpArmorKeysToArmorBlock(char *KeyBlocks)
{
   TStringList *keyblocks = new TStringList(); keyblocks->SetText(KeyBlocks);
   if (retbuf) delete retbuf; retbuf = NULL;

   TPgpDB *pgpdb = new TPgpDB(keyblocks);
   delete keyblocks;

   BUFFER *bigblock = buf_new();
   pgpdb->SaveToBuffer(bigblock);
   pgp_armor(bigblock,2);

   if ((retbuf=new char[bigblock->length+1])!=NULL)
      strcpy(retbuf,(char*)bigblock->data);
   buf_free(bigblock);
   return retbuf;
}
//---------------------------------------------------------------------------
/*char* __fastcall PgpArmorKeysToArmorBlock(char *KeyBlocks)
{
   TStringList *keyblocks = new TStringList(); keyblocks->SetText(KeyBlocks);
   BUFFER *db=buf_new(),*bin=buf_new(),*armor=buf_new();
   if (retbuf) delete retbuf; retbuf = NULL;

//   int c=0; for (int i=0; i<keyblocks->Count; i++)
//      if (keyblocks->Strings[i].Trim()=="-----BEGIN PGP PUBLIC KEY BLOCK-----") c++;
//   if (c>1) keyblocks->SetText(PgpArmorBlockToArmorKeys(keyblocks->Text.c_str()));

   bool inkey=false;
   for (int i=0; i<keyblocks->Count; i++)
   {
      AnsiString line = keyblocks->Strings[i];
      if (line.Trim()=="-----BEGIN PGP PUBLIC KEY BLOCK-----") inkey = true;
      if (inkey) buf_appends(armor,s(line+"\n").c_str());
      if (line.Trim()=="-----END PGP PUBLIC KEY BLOCK-----")
      {
         pgp_dearmor(armor,bin);
         buf_cat(db,bin);
         buf_clear(armor);
         inkey = false;
      }
   }
   pgp_armor(db,2);
   if ((retbuf=new char[db->length+1])!=NULL)
      strcpy(retbuf,(char*)db->data);
   buf_free(armor);
   buf_free(bin);
   buf_free(db);
   delete keyblocks;
   return retbuf;
}*/
//---------------------------------------------------------------------------
char* __fastcall PgpArmorBlockToArmorKeys(char *BigBlock)
{
   TStringList *bigblock = new TStringList(); bigblock->SetText(BigBlock);
   if (retbuf) delete retbuf; retbuf = NULL;

   TPgpDB *pgpdb = new TPgpDB(bigblock);
   delete bigblock;

   TStringList *keyblocks = new TStringList();
   pgpdb->SaveToStrings(keyblocks);

   if ((retbuf=new char[keyblocks->Text.Length()+1])!=NULL)
      strcpy(retbuf,keyblocks->Text.c_str());
   delete keyblocks;

   delete pgpdb;
   return retbuf;
}
/*
char* __fastcall PgpArmorBlockToArmorKeys(char *keyblock)
{
   AnsiString filename = CRingTmp;
   if (FileExists(filename)) DeleteFile(filename.c_str());

   TStringList *block = new TStringList();
   block->SetText(keyblock);
   int c=0; for (int i=0; i<block->Count; i++)
      if (block->Strings[i].Trim().Pos("-----BEGIN PGP ")) c++;
   if (c>1) block->SetText(PgpArmorKeysToArmorBlock(block->Text.c_str()));
   block->SaveToFile(filename);

//sm(block->Text.SubString(1,1024));
//sm(block->Text.SubString(block->Text.Length()-1023,1024));

   delete block;
   if (retbuf) delete retbuf; retbuf = NULL;

   TStringList *keys = new TStringList();
   TPgpDb *pgpdb = new TPgpDb(filename,"");
   TPgpKey *key = pgpdb->FirstKey();
   TStringList *akey = new TStringList();
   while (key)
   {
      BUFFER *armored = buf_new();
      buf_set(armored,key->Key);
      pgp_armor(armored,2);
      akey->SetText((char*)armored->data);
      if (akey->Count)
      {
         akey->Insert(0,key->Description+"\n");
         akey->Add("");
         keys->AddStrings(akey);
      }
      key = key->Next;
      akey->Clear();
   }
   if ((retbuf=new char[keys->Text.Length()+1])!=NULL)
      strcpy(retbuf,keys->Text.c_str());
   delete akey;
   delete pgpdb;
   delete keys;
   return retbuf;
}
*/
//---------------------------------------------------------------------------
/*char* __fastcall PgpGetNewRemailerKeys(char *KeyDoc, char *Type1)
{ // this function respects 'disabled' remailers in type1.list
   AnsiString line,cringtxt=MixDir()+CRingTxt,ctyp1txt=MixDir()+CTyp1Txt;
   TStringList *dockeys = new TStringList();
   dockeys->SetText(KeyDoc);
   dockeys->SaveToFile(CRingTmp);
   delete dockeys;
   if (retbuf) delete retbuf; retbuf = NULL;

   TStringList *type1 = new TStringList();
   TStringList *newkeys = new TStringList();
   if (FileExists(ctyp1txt)) type1->LoadFromFile(ctyp1txt);

   TPgpDb *curdb = new TPgpDb(cringtxt,"");
   TPgpDb *newdb = new TPgpDb(CRingTmp,"");
   TPgpKey *key = newdb->FirstKey();
   while (key)
   {
      bool add=false;
      if (curdb->Find(key)<0)
      {
         add = true;
         for (int i=0; i<type1->Count; i++)
         {
            line = type1->Strings[i];
            if (line.Length() && line[1]=='#' && line.Pos(" 0x"+key->IdText8+" ")>=0)
            {
               add = false;
               break;
            }
         }
      }
      if (add) newkeys->Add(key->Description);
      key = key->Next;
   }

   if (FileExists(CRingTmp)) DeleteFile(CRingTmp.c_str());
   if ((retbuf=new char[newkeys->Text.Length()+1])!=NULL)
      strcpy(retbuf,newkeys->Text.c_str());
   delete newdb;
   delete curdb;
   delete type1;
   delete newkeys;
   return retbuf;
}
//---------------------------------------------------------------------------
char* __fastcall PgpAddNewRemailerKeys(char *KeyDoc, char *Type1)
{
   if (retbuf) delete retbuf; retbuf = NULL;
   TStringList *keydoc = new TStringList();
   keydoc->SetText(KeyDoc); keydoc->SaveToFile(KeyDoc);
   TStringList *type1 = new TStringList();
   type1->SetText(Type1);
   // open pubring.asc and pubring.asc.tmp
   TPgpDb *curdb = new TPgpDb(MixDir()+CRingTxt,"");
   TPgpDb *newdb = new TPgpDb(CRingTmp,"");
   TPgpKey *key = newdb->FirstKey();
   // cycle through pubring.asc.tmp looking for new keys
   while (key)
   {
      AnsiString desc = key->Description;
      if (curdb->FindDescrip(desc)<0 && !InType1("#"+desc,type1))
         curdb->AddKey(new TPgpKey(key->Key));
      key = key->Next;
   }
   curdb->SaveToStrings(keydoc);

   if ((retbuf = new char[keydoc->Text.Length()+1])!=NULL)
      strcpy(retbuf,keydoc->Text.c_str());

   delete curdb;
   delete newdb;
   delete type1;
   delete keydoc;
   return retbuf;
}
//---------------------------------------------------------------------------
bool __fastcall CRingLineOk(AnsiString &line)
{
   return line.Pos("0x")>0;
}
//---------------------------------------------------------------------------
AnsiString __fastcall CpunkCaps(TStrings *rlist, AnsiString &shrtname)
{
   AnsiString caps,line,cap;
   for (int i=0; i<rlist->Count; i++)
   {
      line = rlist->Strings[i];
      if (line.Pos("$remailer{")==1)
      {
         line = GetParam(4,line,"=");
         int r=1; while (!(cap=GetParam(r,line," ")).IsEmpty())
            caps += " "+cap;
      }
   }
   return caps;
}
*/
//---------------------------------------------------------------------------
char* __fastcall PgpEncryptMessage(char *Message)
{
   AnsiString passphrase;
   TStringList *msg = new TStringList(); msg->SetText(Message);
   TStringList *recips = new TStringList();
   THeaderManager *Headers = new THeaderManager(msg);
   Headers->GetRecipsFull("To: ",recips,msg);
   delete Headers;
   if (retbuf) delete retbuf; retbuf = NULL;

   if (!PGPgetEncryptList(recips))
   {
      delete recips;
      delete msg;
      return NULL;
   }

   bool cEncrypt = recips->Text==UseConventional+"\r\n";
   if (cEncrypt && !PGPgetConventionalPassphrase(passphrase,ActMainForm))
   {
      delete recips;
      delete msg;
      return NULL;
   }

   CutMessageAtCutmarks(msg);
   int idx=0; while (idx<msg->Count && !msg->Strings[idx].TrimRight().IsEmpty())
       idx++;
   if (idx>=msg->Count || !msg->Strings[idx].TrimRight().IsEmpty())
   {
      MsgBoxHwnd(AppMainForm->Handle,
         AnsiString("Your message does not appear to have an empty\n")+
         AnsiString("line between headers and body!"),
         "QS PGP Encrypt Error",MB_OK);
      ClearString(passphrase);
      delete recips;
      delete msg;
      return NULL;
   }
   // remove headers and hold for later
   TStringList *mail = new TStringList();
   while (msg->Count>idx+1)
   {
      mail->Add(msg->Strings[idx+1]);
      msg->Delete(idx+1);
   }

   int result=16; // just a non-error number
   if (mail->Count)
   {
      TPgpForm *Pgp = new TPgpForm(PgpPublicRing(),PgpSecretRing(),PgpRemailRing(),ActMainForm);
      if (cEncrypt)
         result = Pgp->EncryptCMessage(mail,passphrase);
      else
         result = Pgp->EncryptMessage(mail,recips);
      delete Pgp;
   }
   else
      MsgBoxHwnd(ActMainForm->Handle,"Nothing to encrypt!","QS PGP Encrypt Error",
         MB_OK);

   if (result==PGP_OK)
   {
      msg->AddStrings(mail); mail->Clear();
      if ((retbuf=new char[msg->Text.Length()+1])!=NULL)
         strcpy(retbuf,msg->Text.c_str());
   }
   delete mail;
   delete recips;
   delete msg;
   return retbuf;
}
//---------------------------------------------------------------------------
char* __fastcall PgpEncryptSignMessage(char *Message)
{
   AnsiString passphrase;
   TStringList *msg = new TStringList(); msg->SetText(Message);
   TStringList *recips = new TStringList();
   THeaderManager *Headers = new THeaderManager(msg);
   AnsiString keyid=Headers->GetDat("From: ");
   Headers->GetRecipsFull("To: ",recips,msg);
   delete Headers;
   if (retbuf) delete retbuf; retbuf = NULL;

   // get list of public keys
   if (!PGPgetEncryptList(recips,NotConventional))
   {
      delete recips;
      delete msg;
      return NULL;
   }
   // open keyrings for signing key
   TPgpDb *pgpdb = new TPgpDb(PgpPublicRing(),PgpSecretRing());
   if (pgpdb->error!=0)
   {
      delete pgpdb;
      delete recips;
      delete msg;
      return NULL;
   }
   TStringList *keys = new TStringList();
   TPgpKey *Key = pgpdb->FirstKey();
   while (Key)
   {
      if (Key->IsPair)
      {
         TPgpKey *skey = Key->SecKey;
         if (skey->UserIds->Count)
         {
            for (int i=0; i<skey->UserIds->Count; i++)
               keys->Add(skey->UserIds->Strings[i]);
         }
      }
      Key = Key->Next;
   }
   delete pgpdb;
   // fail job if no secret keys
   if (!keys->Count)
   {
      MsgBox("No keys found!","QS PGP Error",MB_OK);
      delete recips;
      delete keys;
      delete msg;
      return NULL;
   }
   // pause
   Application->ProcessMessages(); Sleep(200);
   // keys ok, get sign key and passphrase
   int current=keys->IndexOf(keyid);
   int clearsign = GetAppIni(ClearSignMessage,"").ToIntDef(0);
   if (!PGPgetKeyidAndPassphrase(keys,current,passphrase,clearsign,ActMainForm))
   {
      delete recips;
      delete keys;
      delete msg;
      return NULL;
   }
   if (current>=0 && current<keys->Count)
      keyid = keys->Strings[current];
   // ok we have the key, parse it
   int first=keyid.Pos("<")+1,last=keyid.Pos(">")-1;
   keyid = keyid.SubString(first,last?last-(first-1):keyid.Length());
   // prepare message
   CutMessageAtCutmarks(msg);
   int idx=0; while (idx<msg->Count && !msg->Strings[idx].TrimRight().IsEmpty())
       idx++;
   if (idx>=msg->Count || !msg->Strings[idx].TrimRight().IsEmpty())
   {
      MsgBoxHwnd(AppMainForm->Handle,
         AnsiString("Your message does not appear to have an empty\n")+
         AnsiString("line between headers and body!"),
         "QS PGP Encrypt Error",MB_OK);
      ClearString(passphrase);
      delete recips;
      delete keys;
      delete msg;
      return NULL;
   }

   TStringList *mail = new TStringList();
   while (msg->Count>idx+1)
   {
      mail->Add(msg->Strings[idx+1]);
      msg->Delete(idx+1);
   }

   int result=16; // just a non-error number
   if (mail->Count)
   {
      TPgpForm *Pgp = new TPgpForm(PgpPublicRing(),PgpSecretRing(),PgpRemailRing(),ActMainForm);
      result = Pgp->EncryptSignMessage(mail,keyid,passphrase,recips,clearsign);
      delete Pgp;
   }
   else
      MsgBoxHwnd(ActMainForm->Handle,"Nothing to sign!","PGP Error",MB_OK);

   if (result==PGP_OK)
   {
      msg->AddStrings(mail); mail->Clear();
      if ((retbuf=new char[msg->Text.Length()+1])!=NULL)
         strcpy(retbuf,msg->Text.c_str());
      PutAppIni(ClearSignMessage,clearsign?"1":"0");
   }
   delete mail;
   delete keys;
   delete recips;
   delete msg;
   return retbuf;
}
//---------------------------------------------------------------------------
char* __fastcall PgpSignMessage(char *Message)
{
   TStringList *msg = new TStringList(); msg->SetText(Message);
   THeaderManager *Headers = new THeaderManager(msg);
   AnsiString keyid=Headers->GetDat("From: ");
   TStringList *recips = new TStringList();
   Headers->GetRecipsFull("To: ",recips);
   delete Headers;
   if (retbuf) delete retbuf; retbuf = NULL;

   TPgpDb *pgpdb = new TPgpDb(PgpPublicRing(),PgpSecretRing());
   if (pgpdb->error!=0)
   {
      delete recips;
      delete pgpdb;
      delete msg;
      return NULL;
   }

   TStringList *keys = new TStringList();
   TPgpKey *Key = pgpdb->FirstKey();
   while (Key)
   {
      if (Key->IsPair)
      {
         TPgpKey *skey = Key->SecKey;
         if (skey->UserIds->Count)
         {
            for (int i=0; i<skey->UserIds->Count; i++)
               keys->Add(skey->UserIds->Strings[i]);
         }
      }
      Key = Key->Next;
   }
   delete pgpdb;

   if (!keys->Count)
   {
      MsgBox("No keys found!","QS PGP Error",MB_OK);
      delete keys;
      delete recips;
      delete msg;
      return NULL;
   }

   AnsiString passphrase;
   int current=keys->IndexOf(keyid);
   if (!PGPgetKeyidAndPassphrase(keys,current,passphrase,2,ActMainForm))
   {
      delete recips;
      delete keys;
      delete msg;
      return NULL;
   }

   if (current>=0 && current<keys->Count)
      keyid = keys->Strings[current];
   // ok we have the key, parse it
   int first=keyid.Pos("<")+1,last=keyid.Pos(">")-1;
   keyid = keyid.SubString(first,last>=0?last-(first-1):keyid.Length());
   CutMessageAtCutmarks(msg);
   int result=16; // just a non-error number
   if (msg->Count)
   {
      TPgpForm *Pgp = new TPgpForm(PgpPublicRing(),PgpSecretRing(),PgpRemailRing(),ActMainForm);
      Pgp->ToRemailer = Pgp->IsRemailed(recips); // to test for remailer address
      result = Pgp->SignMessage(msg,keyid,passphrase);
      delete Pgp;
   }
   else
      MsgBoxHwnd(ActMainForm->Handle,"Nothing to sign!","PGP Sign Error",MB_OK);

   if (result==PGP_OK)
   {
      //msg->AddStrings(mail); mail->Clear();
      if ((retbuf=new char[msg->Text.Length()+1])!=NULL)
         strcpy(retbuf,msg->Text.c_str());
   }
   delete recips;
   delete keys;
   delete msg;
   return retbuf;
}
//---------------------------------------------------------------------------
char* __fastcall GetPgpLibName()
{
   return AppName.c_str();
}
//---------------------------------------------------------------------------
char* __fastcall GetPgpLibVersion()
{
   return ReleaseVer.c_str();
}
//---------------------------------------------------------------------------
bool __fastcall CutMessageAtCutmarks(TStrings *msg)
{
   bool cut = false;
   if (msg->Text.Pos("\r\n"+CutMarks+"\r\n"))
   {
      while (msg->Count)
      {
         AnsiString line = msg->Strings[msg->Count-1];
         msg->Delete(msg->Count-1);
         if (line.TrimRight()==CutMarks) break;
      }
      cut = true;
   }
   while (msg->Count && msg->Strings[msg->Count-1].IsEmpty())
      msg->Delete(msg->Count-1);
   return cut;
}
//---------------------------------------------------------------------------


